C
C  (n+p)/2 + alpha potential for use in n+p+core calculations
C
	FUNCTION UC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	COMMON /ISOSPIN/ZN,ZC,ISO
	PARAMETER(RAD=2.0)
		CC = 1.44 * ZC * 0.5
		if(R.gt.RAD) VCOUL = CC / R
		if(R.le.RAD) VCOUL = CC * (3.-(R/RAD)**2)/(2.*RAD)
		V=-43.0
		uc=V/(1.d0+ddexp((r-RAD)/0.7d0)) + VCOUL
		RETURN
	ENTRY ULS(L,R)
		s=ddexp((r-1.5d0)/0.35d0)
		uls=-40.d0*s/((1.d0+s)*(1.d0+s))/(0.35d0*r)
		RETURN
	ENTRY ULSC(L,R)
		ULSC = 0d0
		RETURN
	ENTRY ULL(L,R)
		ULL = 0d0
		RETURN
	ENTRY UT(L,R)
		UT = 0d0
		RETURN
	END
	FUNCTION UUC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	COMMON /ISOSPIN/ZN,ZC,ISO
	PARAMETER(RAD=2.0)
		CC = 1.44 * ZC * 0.5
		if(R.gt.RAD) VCOUL = CC / R
		if(R.le.RAD) VCOUL = CC * (3.-(R/RAD)**2)/(2.*RAD)
		V=-43.0
		if(L.eq.0) V=+20.
		UUC=V/(1.d0+ddexp((r-RAD)/0.7d0)) + VCOUL
		RETURN
	END
	FUNCTION UULS(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	UULS = ULS(L,R)
	RETURN
	END
