C ****
C ****  Simple S-wave PP potential
C ****
	FUNCTION VC(L,R)
		IMPLICIT DOUBLE PRECISION(A-H,O-Z)
		include 'actives.f'
	COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE,RCORE,RN,RSCR,XLA,IJT
		VCOUL = 1.44D0/R 
		if(RSCR>0.01) VCOUL = VCOUL *DEXP(-(R/RSCR)**2)
		VC=0D0
		IF(L.EQ.0) VC=-31.D0*DDEXP(-(R/1.8D0)**2) + VCOUL
		RETURN
	ENTRY VLS(L,R)
		if(INIT) ACTIVE(LNNLS)=.false.
		VLS=0.
		RETURN
	ENTRY VT(L,R)
		if(INIT) ACTIVE(LNNT)=.false.
		VT=0.
		RETURN
	ENTRY VLL(L,R)
		if(INIT) ACTIVE(LNNLL)=.false.
		VLL=0.
		RETURN
	END
