c	include 'li11-p2-2.f'
	FUNCTION UC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
		V=-39.33
 		if(L.eq.0) V=V*1.28273
		uc=V/(1.d0+ddexp((r-2.642d0)/0.67d0))
 		if(L.gt.2) uc = 0d0
		RETURN
	ENTRY ULS(L,R)
		as=0.67d0
		s=ddexp((r-2.642d0)/as)
		uls=-35.77d0*s/((1.d0+s)*(1.d0+s))/(as*r)
 		if(L.gt.2) uls = 0d0
		RETURN
	END
c  reli11o13b:  a=0.67, 1p@+0.25, V0=50.45
c  39.33     2.642     0.67      00.0      10.0      2.00
c  35.77     2.642     0.67      0.28273
c  -1   1   1 0.5 -0.25
	FUNCTION UUC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
		V=-39.33
 		if(L.eq.0) V=-6.30 
 		if(L.eq.1) V=-9.80
 		if(L.eq.2) V=V*1.28273
		uuc=V/(1.d0+ddexp((r-2.642d0)/0.67d0))
 		if(L.gt.2) uuc = 0d0
		RETURN
	ENTRY UULS(L,R)
		as=0.67d0
		s=ddexp((r-2.642d0)/as)
		if(L.eq.1) uuls=+4*20.0*s/((1.d0+s)*(1.d0+s))/(as*r)
 		if(L.eq.2) uuls = ULS(L,R)
 		if(L.gt.2) uuls = 0d0
		RETURN
C o13f:
c 5 1  0 6.30   2.642   0.67
c 6 0  0 1.00   00.0    1.27
c 6 1  0 9.800  2.642   0.67
c 6 3  0 -20.0  2.642   0.67
	END
