      SUBROUTINE MINN(R,V3P0,V1P1,V3P1,V3P2,V1D2,V3D2,V1S0,V3S1,V3S3D,
     1V3D1,V3P3F,V3F2,H2SM,TA)
C****
C**** POTENTIEL DE Tang, LeMere et Thompson (Minnesota force, u=1)
C****                 Phys.Rep. 47C (1978) 167
C****
      CHARACTER*50 TA,TAP
      SAVE IN,H2SMP
      DATA IN/1/
      DATA TAP/' Potentiel Minnesota de Tang, Lemere & Thompson' /
      DATA H2SMP/41.496/
C****
      IF(IN.EQ.0)GO TO 2
      IN=0
C****
C**** INITIALISATION
C****
      TA = TAP
      H2SMP=H2SM
      RETURN

    2 CONTINUE
      R=ABS(R)
C                           #######   nn repulsive
            ON1=1.487*R**2
            PUH1=200.0*DDEXP(-ON1)
C                           #######   nn S=1
            ON2=0.639*R**2
            PUH2=-178.0*DDEXP(-ON2)
C                           #######   nn S=0
            ON3=0.465*R**2
            PUH3=-91.85*DDEXP(-ON3)
      V1S0=(PUH1+PUH3)/H2SMP
      V3S1=(PUH1+PUH2)/H2SMP
      V3S3D= 0
      V1P1=0
      V3P0 = 0
      V3P1 = 0
      V3P2 = 0
      V1D2=V1S0
      V3D2 = V3S1
      V3D1 = V3S1

      V3P3F=  0.
      V3F2=0.
      RETURN
      END
