C     ******************************************************************
C
C UC.......CENTRAL INTERACTION REID SOFT CORE, T=0 (NP)
C VC......CENTRAL INTERACTION REID SOFT CORE, T=1  (NN)
C UT.......TENSOR PART
C ULS......LS PART
C
C     ******************************************************************
      FUNCTION UC (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      E=EXP(-X)
      UC=E*(-10.463+E*(105.468+E*E*(-3187.8+9924.3*E*E)))/X
      RETURN
      END
C     ******************************************************************
      FUNCTION VC(L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      E=EXP(-X)
      VC=E*(-10.463-E**3*(1650.6-E**3*6484.2))/X
      RETURN
      END
C     ******************************************************************
      FUNCTION UT (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      Y=1.0/X
      E=EXP(-X)
      UT=E*Y*(-10.463*(1.+3.*Y*(1.+Y)-3.*Y*(4.+Y)*E**3)+
     1E**3*(351.77-1673.5*E*E))
      RETURN
      END
C     ******************************************************************
      FUNCTION ULS (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      E=EXP(-X)
      ULS=E**4*(708.91-2713.1*E*E)/X
      RETURN
      END
C     ******************************************************************
      FUNCTION ULSC(L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      E=EXP(-X)
      ULSC=E**4*(708.91-2713.1*E*E)/X
      RETURN
      END
	FUNCTION VLS(L,R)
	include 'actives.f'
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
		if(INIT) ACTIVE(LNNLS)=.false.
		VLS = 0d0
		RETURN
	ENTRY VT(L,R)
		if(INIT) ACTIVE(LNNT)=.false.
		VT = 0d0
		RETURN
	ENTRY VLL(L,R)
		if(INIT) ACTIVE(LNNLL)=.false.
		VLL = 0d0
		RETURN
	ENTRY ULL(L,R)
		if(INIT) ACTIVE(LNCLL)=.false.
		ULL = 0d0
		RETURN
	END
