      SUBROUTINE BELMAG(EC,KSTHE,NSTHE,JTOT,KSTGS,NSTGS,JTOTI,
     X			BEL,LL,TRCHAN,MCH,A1,A3,Z3,NFI,TRWF,
     X			JTARG,KTARG,QQ0)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      REAL*8 JTOT,JTOTI,JTARG(10),JCLI,JCHE,JLI,JHE
C    ***********************************************************
C  CALCULATION OF B(E1,2) FOR DISCRETISED EIGENSTATE OF REACTION
C  PRODUCTS FOR 3-BODY CONTINUUM
C	Assuming all wavefunctions are in T basis (3)
C
C    ***********************************************************
C *** K,L,S,L1,L2,2*S1,2*S2 - QUANTUM NUMBER    IN ARRAY
      INTEGER KSTHE(MCH,7),KSTGS(NSTGS,7)
      DIMENSION TRCHAN(MCH,MCH),TRWF(MCH,MCH)
      INTEGER PHASE
	LOGICAL TR,TR1,TR2
	TR = .false.
	TR1= .false.
	TR2= .false.
	Z = 0d0
C######################################################################
      A2 = A1
      ASUM = A1 + A2 + A3
      S1 = 0.5D0
      S2 = 0.5D0
CC
C ***   IE - MULTIPOLARITY OF TRANS
      IE = LL
c        WRITE(64,151) IE
  151 FORMAT(3X,'B(E',I1,')   CALCUL. BEGINS          '/)
	JLI = JTOTI
	JHE = JTOT
        AJ = (2.D0*JHE+1)/(2.D0*JLI + 1)
C
      IF(IE .EQ. 1) GO TO 2000
      IF(IE .EQ. 2) GO TO 3000
         GO TO 4000
C
C  ##########################################################################
C
C  ****  E1 TRANSITION
C
C
C
C ****** LOOP ON CONTNUUS SPECTRA  (RADIUS)
2000   AL1 = 1.D0/(4.D0*3.14159D0)*Z3**2*((A1+A2)/(ASUM*A3))

       if(TR1) write(64,*) ' BE:',NSTHE,NSTGS,real(EC),MCH
       SUMR = 0.0
       DO 2002  IF = 1,NSTHE
       KF = KSTHE(IF,1)
        LF = KSTHE(IF,2)
         ISF = KSTHE(IF,3)
          LXF = KSTHE(IF,4)
           LYF = KSTHE(IF,5)
             JNF = KSTHE(IF,6)
               ICF = KSTHE(IF,7)
	       JCHE= JTARG(ICF)
C ****** LOOP ON DISCRET SPECTRA
      DO 2003  II = 1,NSTGS
       KI = KSTGS(II,1)
        LI = KSTGS(II,2)
         ISI = KSTGS(II,3)
          LXI = KSTGS(II,4)
           LYI = KSTGS(II,5)
             JNI = KSTGS(II,6)
               ICI = KSTGS(II,7)
	       JCLI= JTARG(ICI)
C *****  GENERAL CHECK ON INACTIVE Q.N.
	PHASE = (-1)**nint(LI+ISI- JTOTI + LF+ISF-JTOT)
c      WRITE(64,1011) (KSTGS(II,M21),M21=1,7),(KSTHE(IF,M1),M1=1,7)
       IF(ICF .NE. ICI) GO TO 2003
        IF(ISF .NE. ISI) GO TO 2003
         IF(LXF .NE. LXI) GO TO 2003
          IF((KF+1) .LT. KI) GO TO 2003
C
      if(TR1) 
     *WRITE(64,1011) (KSTGS(II,M21),M21=1,7),(KSTHE(IF,M1),M1=1,7)
1011  FORMAT(1X,' < GS ',7I3,' /START/  ',7I3,' > ')
C ********  LOOP ON LY+-1 **************************************
C
            DO 2004 NNL = 1,2
             IF(NNL .EQ. 1) IDLY = -1
             IF(NNL .EQ. 2) IDLY =  1
                  LYI1 = LYI + IDLY
C  *** SELECTION  ON LY
        IF(LYI1 .LT. 0) GO TO 2004
         IF(LYI1 .NE. LYF) GO TO 2004
C ********  LOOP ON KI+-1 **************************************
            DO 2005 NKI = 1,2
             IF(NKI .EQ. 1) IDKI = -1
             IF(NKI .EQ. 2) IDKI =  1
                  KI1 = KI + IDKI
C  *** SELECTION  ON K - 1
        IF(KI1 .LT. 0) GO TO 2005
         IF(KI1 .NE. KF) GO TO 2005
          IF(KI1 .LT. (LXI + LYI1)) GO TO 2005
C  *** SELECTION  ON L - 1, L, L + 1
C ********  LOOP ON L **************************************
C
                  DO 2020 JL = 1,3
        IDL = JL - 2
        LI1 = LI + IDL
            IF (LI1 .LT. 0) GO TO 2020
             IF (LI1 .NE. LF) GO TO 2020
C ***  2020 - END OF LOOP
C
      W = WRACA(1.D0,1.D0*LYI,1.D0*LI1,1.D0*LXI,1.D0*LYI1,1.D0*LI)
        CF = (-1)**nint(1-JLI) * sqrt((2.*JHE+1.)*(2.*JLI+1.)) *
     x       WRACA(JLI,JHE,JNI+Z,JNF+Z,1d0,JCHE)
      if(TR1) WRITE(64,*) 'W,CF =',real(W),real(CF)
        W = W * CF
          IF(W .EQ. 0.D0) GO TO 2020

C   *** 2006 - CALC OF RADAL M.E.
C
	RSU = TRCHAN(IF,II)
	RSU = RSU*PHASE
C
C  ******  CHOICE OF K-DEPENDED COEFFICIENTS
C
        IF((IDLY .EQ. -1) .AND. (IDKI .EQ. -1)) GO TO 2021
                  GO TO 2122
 2021      ALP = -DSQRT(LYI*(KI-LXI+LYI+1.D0)*(KI+LXI+LYI+2.D0)/
     *             (KI+1.D0)/(KI+2.D0))
                  GO TO 2007
C
 2122     CONTINUE
        IF((IDLY .EQ. -1) .AND. (IDKI .EQ. 1)) GO TO 2022
                  GO TO 2123
 2022      ALP = -DSQRT(LYI*(KI-LXI-LYI+2.D0)*(KI+LXI-LYI+3.D0)/
     *             (KI+3.D0)/(KI+2.D0))
                  GO TO 2007
C
 2123     CONTINUE
        IF((IDLY .EQ.  1) .AND. (IDKI .EQ. -1)) GO TO 2023
                  GO TO 2124
 2023      ALP = DSQRT((LYI+1.D0)*(KI-LXI-LYI)*(KI+LXI-LYI+1.D0)/
     *             (KI+1.D0)/(KI+2.D0))
                  GO TO 2007
C
 2124     CONTINUE
        IF((IDLY .EQ. 1) .AND. (IDKI .EQ. 1)) GO TO 2024
                  GO TO 2020
 2024      ALP = DSQRT((LYI+1.D0)*(KI-LXI+LYI+3.D0)*(KI+LXI+LYI+4.D0)/
     *             (KI+3.D0)/(KI+2.D0))
C
 2007   CONTINUE
c     WRITE(64,100) (KSTGS(II,M21),M21=1,7),(KSTHE(IF,M1),M1=1,7)
c    *,RSU,W,ALP,PHASE
c100  FORMAT(' <GS ',7I2,' |E1|',7I2,'>=',3G12.4,I2)
C  *** PARTIAL
	 hch = ALP*0.5D0*DSQRT(2*LI1 + 1.D0)
	
        RSUP = RSU*0.5D0*DSQRT(2*LI1 + 1.D0)*ALP*W * sqrt(AL1)
        SUMR = SUMR + RSUP*(-1)**(1+LI1+LI)
C
       if(TR1) write(2,33) EC,IF,II,sqrt(AL1*W),rsu,hch,rsup,sumr
 33    format('BE:',f6.3,2i4,';',5f9.4)
 2020     CONTINUE
C             END DO
 2005     CONTINUE
 2004     CONTINUE
 2003     CONTINUE
 2002     CONTINUE
 2200     CONTINUE
CC
C   **** SUM OF B(E1) CALCUL   ********************************
C
          BEL = AJ * SUMR**2

C ***** FOR PRINT
C
        WRITE(NFI,378) EC,BEL
	call flush(NFI)
C   **** END OF B(E1) CALCUL   ********************************
C
           GO TO 5000
C-------------------------------------------------------------------------
C
C  *****   E2 CALCUL  ********
C
 3000   CONTINUE
         ALF = Z3*(A1 + A2)/ASUM/A3

           J  = IE
	   L  = IE
	   ISIG=0
C
	SUMR= 0.D0
C
C  **** LOOP ON LI=INIT QUANT. NUMBERS ****
C
C
         DO 3101 NSL = 1,NSTGS
C
      KLI = KSTGS(  NSL,1)
       LLI = KSTGS(  NSL,2)
        ISLI = KSTGS(  NSL,3)
         L1LI = KSTGS(  NSL,4)
           L2LI = KSTGS(  NSL,5)
             JNLI = KSTGS(  NSL,6)
               ICLI = KSTGS(  NSL,7)
	       JCLI = JTARG(ICLI)
C
        if(TR) write(64,94) 'K,L,S,l1,l2,Jn,ii:',
     &              KLI,LLI,ISLI,L1LI,L2LI,JNLI,ICLI
94      format(a20,7i3)
C
C  **** LOOP ON HE=FIN QUANT. NUMBERS ****
C
         DO 3101 NSH = 1,NSTHE
C
      KHE = KSTHE(  NSH,1)
       LHE = KSTHE(  NSH,2)
        ISHE = KSTHE(  NSH,3)
         L1HE = KSTHE(  NSH,4)
           L2HE = KSTHE(  NSH,5)
             JNHE = KSTHE(  NSH,6)
               ICHE = KSTHE(  NSH,7)
	       JCHE = JTARG(ICHE)
          if(TR) write(64,94) '-----prime>',
     &            KHE,LHE,ISHE,L1HE,L2HE,JNHE,ICHE

	PHASE = (-1)**nint(LLI+ISLI- JTOTI + LHE+ISHE-JTOT)
C
	if(TR2) then
       WRITE(64,4646) L1HE ,L2HE ,LHE,ISHE,nint(JHE),KHE
 4646  FORMAT(1X,'<  L1HE1,L2HE ,LHE,ISHE,JHE,KHE =',6I3,' /')
       WRITE(64,4648) L,ISIG,J  
 4648  FORMAT(1X,'/  L  ,ISIG,J   =',3I3,' /')
       WRITE(64,4647) L1LI ,L2LI ,LLI,ISLI,nint(JLI),KLI
 4647  FORMAT(1X,'/  L1LI1,L2LI2,LLI,ISLI,JLI,KLI =',6I3,' >')
	endif

C ****  QUADRUPOLE SELECTION RULES  *************
C
      IF(ICLI.NE. ICHE) GO TO 600
      IF(ISLI.NE. ISHE) GO TO 600
      IF(IABS(KLI - KHE).GT.2) GO TO 600
      IF(IABS(L2LI - L2HE).GT.2) GO TO 600
        IF(L1HE  .NE. L1LI )GO TO 600
C  *****


      CALL ANGSPI(S1,S2,L1HE ,L2HE ,LHE,ISHE,JNHE,L ,ISIG,J,
     *                  L1LI ,L2LI ,LLI,ISLI,JNLI,AS)
        CF = (-1)**nint(2-JLI) * sqrt((2.*JHE+1.)*(2.*JLI+1.)) *
     x       WRACA(JLI,JHE,JNLI+Z,JNHE+Z,2d0,JCHE)
        AS = AS * CF

      CALL HANGMEQ(KHE,L1HE,L2HE,KLI,L1LI,L2LI,HANG)

	if(TR2) WRITE(64,4649) JFK,NSH,NSL,AS,HANG
4649  FORMAT(1X,3I3,': AS,HANG=',2G12.3)

      IF(ABS(AS) .LT. 1.D-10) GO TO 600
C
	  RSU = TRCHAN(NSH,NSL)
	RSU = RSU*PHASE
       SUMR = SUMR + RSU * ALF * AS * HANG

       if(TR) then
	WRITE(64,5515) NSH,NSL,RSU,SUMR
 5515 FORMAT(3X,2I3,' E2,sum E2 =',4G12.4)
 9515 FORMAT(' *** CLUSTER  A=',F3.0,'  Z=',F3.0,' BE2 =',G12.4/)

c      WRITE(64,3120)KHE,LHE,L1HE ,L2HE ,RSU,KLI,LLI,L1LI,L2LI
c3120  FORMAT(' <ex:K,LL,L1,L2=',4I2,'/M=',G11.3,'/gs: ',4I2,'>')
      WRITE(64,3120)NSH,KHE,LHE,L1HE,L2HE ,RSU,AS,HANG,
     x		KLI,LLI,L1LI,L2LI,SUMR
3120  FORMAT(' <ex:#,K,LL,L1,L2=',i3,4I2,'/M=',G11.3,2f8.3,
     x		'/gs: ',4I2,'> =',2g11.3)
	endif
600     continue
C                               CORE E2 contribution using QQ0 and KTARG
c                               QN must agree for all neutrons, not core:
        do 602 i=1,6
602     if(KSTGS(NSL,i).ne.KSTHE(NSH,i)) go to 3101
        if(nint(JCLI+JCHE).lt.2 .or. abs(JCLI-JCHE).gt.2) go to 3101
        CORE = QQ0 * sqrt(2.*JCLI+1.)
     x          * cleb6(JCLI,KTARG,2d0,0d0,JCHE,KTARG)
        AS = (-1)**nint(JNHE+2-JLI-JCHE) * sqrt((2.*JLI+1.))
     x    *  WRACA(JLI,JHE,JCLI,JCHE,2d0,JNHE+Z)
        E2core = AS*CORE

	RSU = TRWF(NSH,NSL)
        RSU = RSU*PHASE

       SUMR = SUMR + RSU * E2core
        if(TR) write(64,590) ' core  ',
     x                  AS,CORE,RSU,E2core*RSU
590     format(a20,5g10.3)

3101  CONTINUE

CC
C   **** B(E2) CALCUL   ********************************
C
          BEL =AJ*SUMR**2
C
C ***** FOR PRINT
C
        WRITE(NFI,378) EC,BEL
	call flush(NFI)
 378     FORMAT(1X,2F10.5)
C   **** END OF B(E2) CALCUL   ********************************

C
 4000   CONTINUE
 5000   RETURN
        END
C
      SUBROUTINE ANGSPI(S1,S2,L1H,L2H,LHE,ISHE,JHE,L ,ISIG,J,
     *                  L1L,L2L,LLI,ISLI,JLI,AS)
        IMPLICIT REAL*8(A-H,O-Z)
C *********************************************************************
C       SPIN - ANGULAR MATRIX ELEMENT FOR DENSITY OPERATOR            *
C               < L,M, SIG,M(SIG)/J,M(J)>                             *
C             IT ACTS ON A SUBSYSTEM 2    (L1H = L1L)                 *
C          CASE OF NUCLON  S1 = S2 = 1/2      *
C *********************************************************************
C                                                                     *
            PI = 3.14159D0
 100     RMES =  DSQRT(6.D0)
        IF(ISIG .EQ. 0) RMES = DSQRT( 2.D0*S1 + 1.D0)
         RMEL =  DSQRT(  2* L2H+1.D0)
         RMEL =  DSQRT(  2* L2L+1.D0)*RMEL
         RMEL =  DSQRT(  2* L  +1.D0)*RMEL
C         WRITE(*,*)' ANGSPI '
C         WRITE(*,*)' ANG 1',L2H,L,L2L,'LH,L,LL'
C         WRITE(64,*)' ANG 1',L2H,L,L2L,'LH,L,LL'
       IF((L+L2L).LT.L2H.OR.(L+L2H).LT.L2L.OR.(L2H+L2L).LT.L)GO TO 1000
         WIG1 =                 WIG(2*L2H,2*L,2*L2L,0,0)
C         WRITE(64,*)' ANG 2'

          IF(WIG1 .EQ. 0.D0) GO TO 1000
C            WRITE(*,8)L2H,L,L2L,WIG1
    8    FORMAT('WIG: L2H,L,L2L=',3I3,G12.3/)
         RMEL =  (-1)**L2H*RMEL*WIG1/DSQRT(4.D0*PI)
 1002     CONTINUE
C
C   ****  NUCLEON CASE : S1 = S2 = 1/2     S1+S2 = 1
C
  311     IF(ISLI.NE. ISHE) GO TO 1000
         A = (-1)**(L1H - L2H + LHE +L + JHE - JLI)*RMES*RMEL
         A = DSQRT( 2.D0*LHE  + 1.D0) * A
         A = DSQRT( 2.D0*LLI  + 1.D0) * A
         A = DSQRT( 2.D0*JLI  + 1.D0) * A
         A = A/DSQRT( 2.D0)
C         WRITE(64,*)' ANG 3',A
	 A0 = A

        A =
     *  WRACA(1.D0*L2H,1.D0*LHE,1.D0*L2L,1.D0*LLI,1.D0*L1L,1.D0*L)* A
C         WRITE(64,*)' ANG 4',A

        AS=
     *  WRACA(1.D0*ISHE,1.D0*LLI,1.D0*JHE,1.D0*L,1.D0*JLI,1.D0*LHE)* A
C         WRITE(*,*)' ANG 5'
c        WRITE(64,10) WIG1,RMEL,A0,A,AS
10	format(' ANG 5',5g11.3)

             RETURN
C ***
 1000   AS= 0.D0
c       WRITE(64,*)' !!!!!!!  ANGSPI: SLECTION RULES !!!!!!!'
c       WRITE(64,*) ' WIG1,ISLI,ISHE=',WIG1,ISLI,ISHE
                END
C
C ************************************************************************
C
        SUBROUTINE HANGMEQ(K,L1,L2I,K1,L12,L22,HANG)
C
        IMPLICIT REAL*8(A-H,O-Z)
C######################################################################
C     Calcul. of hyperangle Mat. El-s for <f/cos(alpha)**2/i>
C             f = He, i = Li
C    *******************************************************************
C
C   *** EL - MAGN RO*COS(TETA)**2 M.E. ****
C
C ***  CALC OF <K L1 L2/RO**2*COS(TETA)**2/K1 L12 L22>    ****
C
	L2 = L2I
C      K  = KSTHE(I,1)
C      LL1= KSTHE(I,2)
C      L1 = KSTHE(I,4)
C      L2 = KSTHE(I,5)
C      K1 = KSTGS(J,1)
C      LL2= KSTGS(J,2)
C      L12= KSTGS(J,4)
C      L22= KSTGS(J,5)
      IF( L1 .NE. L12) GO TO 8765
      IF( L2 .NE. L22) GO TO 9765
       IF(K .NE. K1) GO TO 8767
      IF( L1 .EQ.  L2) GO TO 8766
C
C  ****  LX .NE. LY CASE  ****
C
      AN = (K1-L1-L2)/2.D0
      C1 = (AN+L2+1.5D0)*(AN+L1+L2+2.D0)/(K+3)
      C2 =  AN*(AN+L1+.5D0)/(K+1)
      C1 =  (C1+C2)/(K + 2)
C
	HANG = C1

	RETURN
C
C __________________________________________________________
C   *** CASE KF=KI, LX=LY
C
 8766  C1 = 0.5D0
C
	HANG = C1

	RETURN
C
C
C _________________________________________________________
C  *** CASE ABS(KI - KF) = 2
C
 8767  CONTINUE
C  ***
      IF(IABS(K - K1) .NE. 2) GO TO 8765
	K11 = MAX0(K,K1)
      AN = (K11-L1-L2)/2.D0
      C1 = (AN+L2+0.5D0)*(AN+L1+L2+1.D0)/(K11+2)
      C1 =  AN*(AN+L1+.5D0)/ K11   * C1
      C1 =  DSQRT(C1)/(K11+1)
C
	HANG = C1

	RETURN
C
C _________________________________________________________
C  ****  LYI .NE. LYF CASE  ****
C
 9765 CONTINUE
C
	IF(L2 - L22) 1,8765,2

 2	L2 = L22
         KK = K
          KK1 = K1

	GO TO 10

 1	KK = K1
         KK1 = K

 10     IF (KK1 - KK) 4,5,6

C *****  K1 = K - 2
 4       AN = (KK1-L1-L2)/2.D0
C        WRITE(*,*)'m4 ',KK1,L1,L2
           C1 = (AN+L2+1.5D0)*(AN+L2+2.5D0)*(KK1+2)
      C1 = C1/((AN+L1+L2+3.D0)*(AN+L1+L2+2.D0)*(KK1+4))
	C1 = DSQRT(C1)
      C2 = (AN+L1+L2+2.D0)*(AN+L1+L2+3.D0)/((KK1+2.D0)*(KK1+3.D0))

      C1 =  C1*C2
C
	HANG = C1

	RETURN
C
C

C *****  K1 = K
 5       AN = (KK1-L1-L2)/2.D0
C         WRITE(*,*)'m5 ',KK1,L1,L2

      C1 = (AN+L2+1.5D0)*AN
      C1 = C1/((AN+L1+0.5D0)*(AN+L1+L2+2.D0))
	C1 = DSQRT(C1)
      C2 = 2.D0*(AN+L1+L2+2.D0)*(AN+L1+0.5D0)/((KK1+1.D0)*(KK1+3.D0))

      C1 =  C1*C2

C
	HANG = C1

	RETURN
C
C *****  K1 = K + 2
 6       AN = (KK1-L1-L2)/2.D0
C        WRITE(*,*)'m6 ',KK1,L1,L2,AN
        IF(DABS(AN-1.D0).LE. 1.D-10) GO TO 8765

      C1 = AN*DABS(AN - 1.D0)*(KK1+2)
C        WRITE(*,*)'C1',C1
      C1 = C1/((AN+L1+0.5D0)*(AN+L1-0.5D0)*KK1)
C        WRITE(*,*)'C1',C1
        C1 = DSQRT(C1)
      C2 = (AN+L1+0.5D0)*(AN+L1-0.5D0)/((KK1+2.D0)*(KK1+1.D0))

      C1 =  C1*C2
C
	HANG = C1

C        WRITE(*,*)'M6',HANG
	RETURN
C
C
 8765 CONTINUE
C
	HANG = 0.D0
        WRITE(*,*)'HANGMEQ: SELECTION RULES HANG=',HANG

C
C   **** END OF HYPERANGLE MAT. EL. CALCUL   ********************************
       RETURN
	END
