*==> denanr64.f <==   (Copied from sturm/denanr48.f)
      SUBROUTINE DENANR (FUN,NMAR,KST,NSTATE,ENGY,RCORE,A1,A3,Z1,Z3,
     x		step,IMAX2,MCHAN,numrmax,MCH,ryev,NSMS)
C *** DENSITY OF N+N AS A FUNCTION OF   CORE-P+P DISTANCE
C
      IMPLICIT DOUBLEPRECISION (A-H,O-Z)
      DIMENSION KST(NSTATE,7)
      DIMENSION   FUN(MCHAN,numrmax)
      DIMENSION DNN(NSMS),WNN(NSMS),WEI(NSTATE)
      logical tail
      parameter (tail =.false.)
	write(10,*) 'DENANR:'
C   efaddx:
	H  = step
	wrad  = step
	RM = H*NMAR
	WVK =SQRT(MAX(-ENGY,0d0)/ryev)
	write(10,*) 'RM,H,WVK,NSTATE =',RM,H,WVK,NSTATE
	A2 = A1
C
      S2    = DSQRT(0.5D0)
      S3   =  DSQRT(1.D0/3.D0)
      S23   =  S3*2.D0
      SPI   =  DSQRT(2.D0/3.141592D0)
      DO 977 I = 1,NSMS
      WNN(I) = 0.D0
 977  DNN(I) = 0.D0
      WEI(:) = 0.
      T1 = 0.D0
      T2= 0.D0
      T4= 0.D0
      T5= 0.D0
      T6= 0.D0
      T7= 0.D0
      T8= 0.D0
      T9= 0.D0
      T10=0.D0
C
      DO 51 J = 1,NMAR
      rrad = J*step
      RO2=rrad**2
      T = 0.D0
C
      DO 52 I = 1,NSTATE
        DNN(I) = DNN(I) + FUN(I+IMAX2,J)**2*RO2 * wrad
        T = T + FUN(I+IMAX2,J)**2 * wrad
        WNN(I) = WNN(I) + FUN(I+IMAX2,J)**2 * wrad
	WEI(I) = WNN(I)
  52  continue
      T2 =T2+ T
  51  T1 =T1+ T*RO2

       DO 993 I = 1,NSTATE
 993  WRITE(10,997) (KST(I,J),J=1,5),DNN(I),WNN(I)
      DO 994 I = 1,NSTATE
 994  WNN(I) = 0.D0
C 993  CONTINUE
	if(ENGY.lt.0.0.and.tail) then
      DO752 I = 1,NSTATE
      asa=FUN(  I+IMAX2,NMAR)**2*(RM**2+RM/WVK+0.5D0
     *  /WVK**2)/(2.D0*WVK)
       WRITE(10,9197) wvk,asa,fun(i,nmar),rm
 9197  format(1x,4g14.4)
      DNN(I) = DNN(I)    +asa
 752  CONTINUE
	endif
C
C
      DO 7788 I = 1,NSTATE
      T7 = T7 + DNN(I)
	if(ENGY.lt.0..and.tail) T2=T2+FUN(I+IMAX2,NMAR)**2/(2D0*WVK)
7788  continue
      RO2 = T7   /T2
       RSUM = 0.D0
       DO 988 I = 1,NSTATE
       DNN(I) = DNN(I)   /T2
       WRITE(10,997) (KST(I,J),J=1,5),DNN(I)
 988    CONTINUE
C ***  CALC OF <K L1 L2/RO**2*COS(TETA)**2/K1 L1 L2>    ****
       IJ = 1
       cs2 = 0.d0

      DO 8765 I = 1,NSTATE
      K  = KST(I,1)
      LL1= KST(I,2)
      JS1= KST(I,3)
      L1 = KST(I,4)
      L2 = KST(I,5)
       JBEG  = I
      DO 8765 J = JBEG,NSTATE
      K1 = KST(J,1)
      LL2= KST(J,2)
      JS2= KST(J,3)
      L12= KST(J,4)
      L22= KST(J,5)
	WNN(IJ) = 0.
      IF(LL1 .NE. LL2) GO TO 8765
      IF(JS1 .NE. JS2) GO TO 8765
      IF( L1 .NE. L12) GO TO 8765
      IF( L2 .NE. L22) GO TO 8765
       IF(I .NE. J) GO TO 8767
      IF( L1 .EQ.  L2) GO TO 8766
      AN = (K1-L1-L2)/2.D0
      C1 = (AN+L2+1.5D0)*(AN+L1+L2+2.D0)/(K+3)
      C2 =  AN*(AN+L1+.5D0)/(K+1)
      C1 =  (C1+C2)/(K + 2)
       WNN(IJ) = DNN(I)*C1
       WRITE(10,229)K,LL1,JS1,L1,L2,K1,LL2,JS2,L12,L22,WNN(IJ)
       IJ = IJ + 1
       cs2 = cs2 + C1*WEI(I)

         GO TO 8765
C
 8766  C1 = 0.5D0
       WNN(IJ) = DNN(I)*C1
C       WRITE(10,229)K,LL1,JS1,L1,L2,K1,LL2,JS2,L12,L22,WNN(IJ)
       IJ = IJ + 1
       cs2 = cs2 + C1*WEI(I)

         GO TO 8765
C
 8767  CONTINUE
       IF((K+2) .NE.K1) GO TO 8765
      AN = (K1-L1-L2)/2.D0
      C1 = (AN+L2+0.5D0)*(AN+L1+L2+1.D0)/(K1+2)
      C1 =  AN*(AN+L1+.5D0)/ K1   * C1
      C1 =  DSQRT(C1)/(K1+1)
      weind = 0.d0
      DO 9651 M = 1,NMAR
      rrad = M*step
      R2=rrad**2
      weind=weind+ FUN(I+IMAX2,M) * FUN(J+IMAX2,M) * wrad
 9651 WNN(IJ)=WNN(IJ)+ FUN(I+IMAX2,M) * FUN(J+IMAX2,M)* R2 * wrad

	if(ENGY.lt.0.0.and.tail) then
      AAA = FUN(I+IMAX2,NMAR)*FUN(J+IMAX2,NMAR)*(RM**2 + RM/WVK +
     * 0.5/WVK**2)/(2.*WVK)
      WNN(IJ)=WNN(IJ) + AAA
	endif
      WNN(IJ)=WNN(IJ)  * 2.D0 * C1
      cs2 = cs2 + 2.d0*C1*weind
C       WRITE(10,229)K,LL1,JS1,L1,L2,K1,LL2,JS2,L12,L22,WNN(IJ)
 229   FORMAT('<',5I2,'/RO**2*COS(TETA)**2/',5I2,'> =',G12.4)
        IJ  =  IJ + 1
C        GO TO 8765
 8765 CONTINUE
C
          IJ = IJ - 1
         ASUM = A1 + A2 + A3
      ROS = DSQRT(RO2)
      WRITE(6,123)RO2,ROS,T2
      RO2M = RO2/ ASUM
      RO2MS= DSQRT(RO2M)
      WRITE(6,126 )RO2M,RO2MS,T2
C **   RLI9 = 2.32 FM
C        RA2 = 1.45D0**2
C       RA2 = 2.32D0**2
        RA2 = RCORE**2
      RO2M = A3* RA2/ ASUM + RO2M
      RO2MS= DSQRT(RO2M)
      WRITE(6,127 )RO2M,RO2MS
 123  FORMAT(1X,'RO**2=',G12.4,5X,'RO MEAN=',G12.4,' NORM=',F12.5)
 126  FORMAT(1X,'RM**2=',G12.4,5X,'RM MEAN=',G12.4,' NORM=',F12.5)
 127  FORMAT(1X,'RM**2+RCOR**2=',G12.4,5X,'RMAT MEAN=',G12.4)
C     WRITE(6,124)T4 ,T5 ,T6,T8,T9,T10
C124  FORMAT(1X,'RO2*2=',G12.4,5X,'R24 * 2=',G12.4,'RS1*2=',G12.4/
C    *       1X,'R46*2=',G12.4,5X,'R460* 2=',G12.4,'RS146*2=',G12.4/)
C
 997  FORMAT(1X,'K,L,S,L1,L2=',5I3,' RO**2=',G12.4,:,' NM:',F10.5)
C ***  COMP   RALF,RNN,RN,RAN MEAN SQUARED
        RSUM = 0.D0
      DO  5783  II = 1 , IJ
c     write(10,*) real(wnn(ii))
 5783  RSUM  = RSUM + WNN(II)
      write(10,*) 'DENANR:',IJ,', SUM :',RSUM
       write(6,1800)cs2,RO2*cs2,RSUM
1800  format(1x,60('*')/1x,'<cos**2>',f8.3,'  ro**2*<cos**2>',f8.3,
     *  '  <ro**2*cos**2>',f8.3/1x,60('*')/)
C
C ***  N=A1=A2   R**2 = 0.5*(R1**2 + R2**2)
C
      RN2 = 0.5D0*(RO2 - RSUM*(1.D0 - A3/ASUM))/A1
      RN  = DSQRT(RN2)
      RAL2 = RSUM*2.D0*A1/(ASUM*A3)
      RAL  = DSQRT(RAL2)
      RNN2 = 2.0D0*(RO2 - RSUM)/A1
      RNN = DSQRT(RNN2)
      RAN2 = RSUM/A3 + RO2/(2.D0*A1)
      RAN  = DSQRT(RAN2)
      RALPHA = RAL * ASUM/(2d0*A1)
      RALPHA2= RALPHA**2
      ENWSR = 3.d0 * (Z3*A1/ASUM)**2 * RALPHA2 / 3.141592D0
      EWSR = Z3**2/(ASUM*4d0*3.141592D0) * ryev * 18d0/A3
      WRITE(6,1272)RALPHA,ENWSR,EWSR
1272  FORMAT(1X,'Rrms=',G12.4,5X,' NEWSR=',G12.4,3X,'EWSR=',G12.4/)
      WRITE(6,753)RN2,RN,RAL2,RAL,RNN2,RNN,RAN2,RAN
 753  FORMAT(1X,60(1H*)/1X,'*  RN**2 =',G15.4,10X,'RN =',G15.4,5X,'*'/
     *                  1X,'*  RC**2 =',G15.4,10X,'RC =',G15.4,5X,'*'/
     *                  1X,'*  RNN**2=',G15.4,10X,'RNN=',G15.4,5X,'*'/
     *                  1X,'*  RCN**2=',G15.4,10X,'RCN=',G15.4,5X,'*'/
     *     1X,60(1H*)/)
      RETURN
      END

