	module groundstate
      	INTEGER IMAX3GS,PARITI,NN0
      	REAL*8 JTOTI
      	INTEGER,allocatable:: KSTGS(:,:)
      	REAL*8,allocatable:: PVECGS(:),PJ0(:,:,:,:)
	end module groundstate

	SUBROUTINE EIGENS(NBS,LV,JV,JTOT,PTY,NX,DX,NY,DY,YBS,ASPL,NLAG,
     1            RR,KAPP,KK2,LLTOT2,SSTOT2,LL12,LL22,II2,JNN2,KIND,
     1            LNCMAX,NSRC,KK3,LLTOT3,SSTOT3,LL13,LL23,II3,JNN3,
     2            JTARG,PTARG,TT,LDMIN,LDMAX,L2MAX,SMAX, RMAX,NPLAG,
     T          IMAX2,IMAX3,IMAX,ZC,AC,AN,SN,RN,WN1,NJAC,XJ,WJ,XL,WL,PJ,
     3            MLAG,MJAC,NYMAX,MX,NYP2,MCH,MCH3,MNM,MAXL,MLT,MKMAX,
     5		  ML,MLL,MNMAX,NMAX,RL,WM,PRIPOT,EQN,ZEFF,coulcn,
     6		  H2M,ETARG,VALR,EMIN,VECSR,PSIGN,NTR,PRT,
     7            WW,mxfile,IJT,MEIGS,MBS,ICV,JTV,KNF,KNL,MAXEQ,
     8		  isr,nfound,MOMDIS,IMAX2Y,IMAX2Z,IMAXH,RCORE,IO,
     a 		  EMAX,DE,NN,EPS2,BEV,N3BLOCK,
     b		  CTN,DTN,KKN,ICN,IMAXN,FESH,IFO,IMAXF,Kmaxf)
	use groundstate
      	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	integer dp 
	parameter(dp = selected_real_kind(12), lanmax=100)
	REAL*8 LAGNORM,J1,J2,JT,KTARG
c	REAL*4 RCORE
      DIMENSION XJ(MJAC),WJ(MJAC),  XL(MLAG),WL(MLAG)
      DIMENSION PJ(0:MNM,0:MAXL,-MLT:MLT,MJAC)
      DIMENSION WN1(MCH,MCH),CHNM(MCH),PCHNM(MCH),SUM(2),CTN(MCH,MCH),
     & 		DTN(MCH,MCH)
      INTEGER KK3(MCH),LL13(MCH),LL23(MCH),LLTOT3(MCH),SSTOT3(MCH),
     &        KK2(MCH),LL12(MCH),LL22(MCH),LLTOT2(MCH),SSTOT2(MCH),
     &	      JNN3(MCH),II3(MCH),JNN2(MCH),II2(MCH),isr(MEIGS),
     & 	      KSTEX(MCH,7),STR,IO(MCH,2),Kmaxf(NTARG),
     &	      KKN(MCH),ICN(MCH),IFO(MCH,3)

      DIMENSION WW(MCH,MCH,MLAG),RL(0:abs(NMAX),NLAG),WM(ML,ML)
      REAL*8 VECNM(MLL),VEC(MLL),PVEC(MLL)
      real(KIND=dp),allocatable:: VECSI(:,:)
      DIMENSION VECSR(MLL,MEIGS),
     &          VALR(MEIGS),NITER(MLL),VALI(MEIGS),
     &          PLSNORM(0:5,0:1,0:5),PLNORM(-1:5),CONSFLT(4),EIMAG(4),
     & 	        TRCHAN(MCH,MCH,0:1),DSDE(MLL),BEL(MLL,0:2),BELT(2,4),
     & 		RPOWER(0:MNMAX,0:MNMAX),CNORM(5),CNNORM(0:5,5),
     & 	        ALAN(lanmax,lanmax+3),veclan(MLL,lanmax)

        COMMON /DEFORM/NTARG,KKKMAX,KTARG,DEF(2:5),BETA(2:5),
     X                  VOLCON,CONS,QQ(2:5)
	INTEGER PTY,SMAX,SS,TT,KIND(MBS)
	CHARACTER PSIGN(3),eigen*5,EQN
	CHARACTER LNAMES(0:14),LLNAMES(0:14)
	DATA LNAMES / 's','p','d','f','g','h','i','j','k','l','m',
     &                'n','o','p','q' /
	DATA LLNAMES / 'S','P','D','F','G','H','I','J','K','L','M',
     &                'N','O','P','Q' /
	DOUBLEPRECISION YBS(MX,MBS),JV(MBS),KAPP,ASPL(0:NYP2,0:NYMAX)
      	DOUBLE PRECISION JTARG(NTARG),ETARG(NTARG),JTOT,JTV(MBS)
	INTEGER LV(MBS),PTARG(NTARG),ICV(MBS),KNF(NBS),KNL(NBS),PRT(MBS)
	DIMENSION XNI(MCH),BEV(MBS)
      	DIMENSION EVALS(10)
	real time(2)

        DIMENSION tj(MJAC),FC(MKMAX+2),BESSJ(MKMAX+2,NTARG)
        real(KIND=dp),allocatable:: CHIP(:,:),Proby(:,:)
	
      	LOGICAL PRIPOT,PR,FOUND,JUSTGS,CHIPPED,VOLCON,CONS,
     X			FESH,MOMDIS
	parameter (Z=0d0)
	data EIMAG / 0.5, 0.75, 1.0, 0.3 / 

C COMPLETE MATRIX ELEMENTS
c	write(6,*) NBS,JTOT,PTY,NX,DX,NY,DY,NLAG
c	write(6,*)  RR,KAPP
c	write(6,*)  LNCMAX,NSRC
c	write(6,*)  NTARG,TT,LDMIN,LDMAX,L2MAX,SMAX, RMAX
c 	write(6,*)  IMAX2,IMAX3,IMAX,ZC,AC,AN,SN,NJAC
c	write(6,*)  MLAG,MJAC,NYMAX,MX,NYP2,MCH,MCH3,MNM,MAXL,MLT,MKMAX
c	write(6,*)  ML,MLL,MNMAX,NMAX,PRIPOT,EQN
c	write(6,*) ' COMPLETE MATRIX ELEMENTS'
	write(6,*)  'IMAXH,MCH3 =',IMAXH,MCH3

	IIMAX=(abs(NMAX)+1)*IMAXH
	IIIMAX=(abs(NMAX)+1)*IMAXH
C STORING HYPERRADIAL SUBSIDUARY ARRAYS

	open(74)
	S2 = 1d0/sqrt(RR)
	DO 202 J=1,NLAG
	U=XL(J)
	S=U**2.5d0 * exp(-U*0.5d0)
	DO 20 N=0,abs(NMAX)
20	RL(N,J)=POLAG(N,5.D0,U)*LAGNORM(N,5.D0)	* S
	write(74,201) U*RR,(S2*RL(N,J),N=0,min(10,abs(NMAX)))
201     format(f7.3,12g11.3)
202	CONTINUE
	if(.false.) then
	DO 207 NN=0,-abs(NMAX),12
	  do 206 r=0.05,XL(NLAG)*RR,0.05
	    U = r/RR
            S=U**2.5d0 * exp(-U*0.5d0) / sqrt(RR)
	DO 205 N=NN,min(abs(NMAX),NN+11)
205	VEC(N-NN+1)=POLAG(N,5.D0,U)*LAGNORM(N,5.D0)	* S
206	write(101,201) r,(VEC(N-NN+1),N=NN,min(abs(NMAX),NN+11))
	write(101,*) '&'
207	CONTINUE
	endif
	  do 312 N=0,abs(NMAX)
	  do 312 N1=0,abs(NMAX)
	   r2 = 0.0
	   do 311 i=1,NLAG
311	   r2 = r2 + (XL(i)*RR)**2 * WL(i) * RL(N,i) * RL(N1,i)
312	   RPOWER(N,N1) = r2
	write(6,*) ' Gauss-Laguerre basis calculated'
!	call etime(time); write(6,'('' cpu: '',f8.3)') time(1)

C THE MATRIX ELEMENTS
	HH=H2M/(RR*RR)
	DO 21 I=1,min(IMAXH,MCH3)
	DO 22 N=0,abs(NMAX)
	II=(abs(NMAX)+1)*(I-1)+N+1
	DO 23 I1=1,min(IMAXH,MCH3)
	DO 24 N1=0,abs(NMAX)
	II1=(abs(NMAX)+1)*(I1-1)+N1+1
	S=0.
	DO 25 J=1,NLAG
25	S=S+RL(N,J)*RL(N1,J)*WW(I,I1,J)*WL(J)
	WM(II,II1)=S
	 ICI = I
!					REDCHS not called yet!
	 if(FESH) ICI = IFO(I,1)
	K=KK2(ICI)
	if(EQN.eq.'T') K=KK3(ICI)
	if(EQN.eq.'N') K=KKN(ICI)
	IC=II2(ICI)
	if(EQN.eq.'T') IC=II3(ICI)
	if(EQN.eq.'N') IC=ICN(ICI)
	IF(I.EQ.I1)   WM(II,II1)=WM(II,II1)+EKIN(N,N1,K)*HH
	IF(II.EQ.II1) WM(II,II1)=WM(II,II1)+ETARG(IC)
24	CONTINUE
23	CONTINUE
22	CONTINUE
21	CONTINUE
	write(6,*) ' Matrix elements found in Gauss-Laguerre basis'
!	call etime(time); write(6,'('' cpu: '',f8.3)') time(1)
!	write(6,*) ' Eigens: NPLAG =',NPLAG
C---------------------------------- CALCULATE FORBIDDEN STATES IN HH BASIS:
        Eshift=10000.d0
	IF(NY.gt.0.or.N3BLOCK>0)
     *	call PPX(NBS,LV,JV,JTOT,PTY,NX,DX,NY,DY,YBS,ASPL,NLAG,RR,KAPP,
     1              IMAX2,kk2,lltot2,sstot2,ll12,ll22,LNCMAX,IMAX,NSRC,
     2              NTARG,JTARG,JNN2,II2,PTARG,LDMIN,LDMAX,MAXEQ,
     T              KIND,AC,AN,SN,WN1,NJAC,XJ,WJ,XL,WL,PJ,IO,NKILL,
     3              MLAG,MJAC,NYMAX,MX,NYP2,MCH,MCH,MNM,MAXL,MLT,MLL,
     5		    ML,MNMAX,abs(NMAX),RL,WM,PRIPOT,EQN,MBS,ICV,JTV,
     6	            KNF,KNL,NPLAG,CTN,IMAXN,FESH,IFO,IMAXF,EPS2,N3BLOCK)

	call REDCHS(EQN,.true.,WN1,CTN,JNN3,II3,JNN2,II2,
     x     KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     x	   KKN,ICN,IMAXN,IMAXH,MCH,IMAX2,IMAX3,IMAX,FESH,IFO,IMAXF)


	write(6,*)
	WRITE(6,*)' Matrix of size ',IIMAX,' to be diagonalised'
!	call etime(time); write(6,'('' cpu: '',f8.3)') time(1)
	call flush(6)
c --------------------------------------------
c  	if(prmats) then
!   	   write(6,*) 'WM interaction matrix:'
!   	   call wrtmat(WM,IIMAX,IIMAX,ML,6)
c 	 endif	
c --------------------------------------------
	NEVALS = 0
	JUSTGS = IJT.eq.1.and.DE.lt.0.
	if(NMAX.gt.0.or. JUSTGS ) then
C                            just find up to 4 eigenvalues nearest EMIN:
	  iv2 = min(ML,MEIGS,4)
	  if(JUSTGS) iv2 = min(ML,MEIGS,1)
!	  write(6,*) 'Look for ',iv2,' eigenstates. ',ML,MEIGS

	  if(EQN.eq.'T'.and.IMAXH.gt.MCH3) then
		write(6,*) ' IMAXH,MCH3 =',IMAXH,MCH3
!		if(EQN.eq.'N') stop 'N-lancs'
		IIIMAX=(abs(NMAX)+1)*MCH3
	   call gsfind(KK2,LLtot2,sstot2,LL12,LL22,JNN2,II2,abs(NMAX),
     x                 IIMAX,IMAX,vecsr(1,1),RR,valr(1),FOUND)
	   if(FOUND) then
		write(6,*)
		WRITE(6,*)' Starting with previous eigenstate at E =',
     x				real(valr(1))
	     else	
		write(6,*)
		WRITE(6,*)' Stored matrix of size ',IIIMAX
	   call laneig(WM,ML,MLL,IIIMAX,valr,vecsr,iv2,2d-4,vecnm,
     x			min(lanmax,IIIMAX),veclan,ALAN,ALAN(1,lanmax+1),
     x			ALAN(1,lanmax+2),ALAN(1,lanmax+3),pvec)
 		do 50 iv=1,iv2
		do 50 II=IIIMAX+1,IIMAX
50		vecsr(II,iv) = 0.0
	     endif
		write(6,*)
		WRITE(6,*)' Generate matrix of size ',IIMAX
	   call laneigm(MLL,IIMAX,valr,vecsr,iv2,1d-3,vecnm, abs(NSRC),
     x			min(lanmax,IIMAX),veclan,ALAN,ALAN(1,lanmax+1),
     x			ALAN(1,lanmax+2),ALAN(1,lanmax+3),pvec,
     x		        HH,IMAXH,MCH,abs(NMAX),NLAG,RL,WL,WW,
     x 			KK2,KK3,II2,II3,ETARG,EQN,MNMAX)
c	    write(6,*) ' Lanczos gs at ',real(valr(1))
	  else
	   call invitrm(WM,ML,MLL,IIMAX,valr,vecsr,iv2,EMIN,1d-10,50,
     x			vecnm,pvec,.true.)
!	call etime(time); write(6,'('' cpu: '',f8.3)') time(1)
	  endif

	  do i=1,iv2
	  vali(i) = 0d0
	  enddo
	else
C 			     find all eigenvalues (complex in general)
	  IFAIL=0
	  write(6,*) ' Find all eigensolutions'
      		allocate(VECSI(MLL,MEIGS))
	  call f02agf(WM,ML,IIMAX,valr,vali,vecsr,MLL,VECSI,MLL,NITER,
     x			IFAIL)
      		deallocate(VECSI)
	  iv2=IIMAX
	  write(6,*) ' Found ',iv2,' eigensolutions'
	endif
	  thresh = 0.001
	  if(EQN.eq.'F') write(6,12) thresh
12	format(/' Renormalising eigenstates with treshhold =',1p,e12.2)
C
	EGS = 1d5
	iv0 = 0
        do 101 iv=1,iv2
	 if(valr(iv).lt.EGS) then
		iv0  = iv
		EGS = valr(iv)
		endif
101	continue
	do 505 iff=6,mxfile,4
505	write(iff,510) JTOT,PSIGN(PTY+2),EGS
510	format(/' Ground state',f5.1,A1,' ENGY =',f12.6)
	call flush(iff)
c				Write out details of gs eigenvector
	if(.true.) then
	write(35,*) RR,EGS
	do 102 I=1,IMAXH
	do 102 N=0,abs(NMAX)
	II=(abs(NMAX)+1)*(I-1)+N+1
102	write(35,103) KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(I),N,vecsr(II,iv0)
103	format(8I3,G22.12)
	do 104 I=1,min(IMAX3,IMAXH)
	    KSTEX(I,1) = KK3(I)
	    KSTEX(I,2) = LLTOT3(I)
	    KSTEX(I,3) = SSTOT3(I)
	    KSTEX(I,4) = LL13(I)
	    KSTEX(I,5) = LL23(I)
	    KSTEX(I,6) = JNN3(I)
	    KSTEX(I,7) = II3(I)
!	    write(35,*) 'KSTEX:',I,(KSTEX(I,J),J=1,7),' @ ',IJT
104	   continue
	endif

	if(EQN.eq.'N') then
	  rewind 28
	  read(28,*) IMAX2,IMAX3,IMAX
	  write(6,*) 'Reexpand from ',IMAXN,' to ',IMAX,', ',IMAX2,IMAX3
	  do 308 I=1,IMAX
308       read(28,*) II,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(I),(WN1(I,I1),I1=1,IMAX)
   	 endif
	IIMAX=(abs(NMAX)+1)*IMAX
	IIIMAX=(abs(NMAX)+1)*IMAXH

	    if(IJT>1) then
	    write(4,*) 'valr(iv0):',valr(iv0)
	    do I=1,IMAX3GS
	    write(4,*) 'KSTGS:',I,(KSTGS(I,J),J=1,7),' @ ',IJT
	    call flush(4)
	    enddo
	    endif
	nfound=0
!	DO 500 iv=iv2,1,-1
	DO 500 iv=1,iv2,1
	if(iv2.gt.1) write(14,*) iv,' ',valr(iv),' ',vali(iv),NITER(iv)
	if(EMAX.lt.EMIN.and.valr(iv).gt.4.0) go to 500
	  write(10,*) ' Consider e-state ',iv,' as ',valr(iv),' < ',EMAX
	if(EMAX.gt.EMIN.and.valr(iv).gt.EMAX.and.iv.ne.iv0) go to 500
	  write(10,*) ' Analyse e-state ',iv,' as ',valr(iv),' < ',EMAX
	if(.not.FESH) then
	  do 310 II=1,IIIMAX
310	  vec(II) = vecsr(II,iv)
	else
	  write(6,*) 'Redistribute from ',IMAXH,' Feshbach basis'
	  do 313 II=1,MLL
313	  vec(II) = 0d0
	  do 3131 I=1,IMAXH
	  do 3131 N=0,abs(NMAX)
	    II=(abs(NMAX)+1)*(I-1)+N+1
	    II1=(abs(NMAX)+1)*(IFO(I,1)-1)+N+1
3131	  vec(II1) = vecsr(II,iv)
	endif
	if(iv.eq.1.or.valr(iv).le.EMAX) then
	   nfound = nfound+1
	   isr(nfound) = iv
	endif
	 if(NEVALS.lt.10) then
	   NEVALS = NEVALS+1
	   EVALS(NEVALS) = valr(iv)
	 endif
  	NSRCWF = 0
	if(.false..or.NSRCWF/=0) then
 	rewind 25
	write(6,*)
!	if(NSRCWF/=0) write(6,*) ' REPLACING WF BY PP STATE ',NSRCWF
	write(6,*) ' IIMAX,MLL =',IIMAX,MLL
 	do 316 ISRC=1,abs(NSRC)
 	   read(25) (pvec(II),II=1,IIMAX)
!	   write(190,*) ' PP state ',ISRC
!	   write(190,'(1x,10f8.4)') pvec(1:IIMAX)
	   if(ISRC==NSRCWF) then
	     vec(1:IIMAX) = pvec(1:IIMAX)
	     write(6,*) ' REPLACING WF BY PP STATE ',NSRCWF
	     endif
	     xnn = 0
	     do II=1,IIMAX
	     xnn = xnn + pvec(II)**2
	     enddo
 	   xn = 0.0
 	   do 314 II=1,IIMAX
 314	   xn = xn + vec(II) * pvec(II)
 316	   write(6,*) ' overlap of solution ',iv,' with PP state ',
     x       ISRC,' is ',real(xn),'  (from ',real(xnn),')'
	endif

	if(EQN.eq.'N') then
c				RECONSTRUCT FADDEEV Y,T EIGENVECTOR
	write(6,*) 'Reexpand eval ',iv,' from ',IMAXN,' to ',IMAX
	  DO 320 I=1,IMAX
	  DO 320 N=0,abs(NMAX)
	    II=(abs(NMAX)+1)*(I-1)+N+1
	    S = 0d0
	    do 318 I1=1,IMAXN
	        II1=(abs(NMAX)+1)*(I1-1)+N+1
318		S = S + CTN(I,I1)*vec(II1)
320	    pvec(II) = S
	  DO 321 II=1,IIMAX
321	    vec(II) = pvec(II)
	endif
	
C ***** Normalise solution vector with norm matrix WN1
c	  write(6,*) ' Normalise e-state ',iv
	  do 3215 II=1,MLL
3215 	  pvec(II) = 0d0
	S2 = 0.0
	DO 324 I=1,IMAX
	DO 324 N=0,abs(NMAX)
	II=(abs(NMAX)+1)*(I-1)+N+1
	S=0.
	DO 322 I1=1,IMAX
	N1=N
	II1=(abs(NMAX)+1)*(I1-1)+N1+1
	if(FESH.and.EQN.ne.'N') II1=(abs(NMAX)+1)*(IFO(I1,1)-1)+N1+1
322	S=S+WN1(I,I1)*vec(II1)
	II1 = II
	if(FESH.and.EQN.ne.'N') II1=(abs(NMAX)+1)*(IFO(I,1)-1)+N+1
	pvec(II1) = S
	S2 = S2 + S*vec(II1)
324	continue
c	  write(6,*) '  E-state ',iv,' has initial norm',real(S2)
	if(S2.le.thresh) then 
	   write(6,*) '  E-state ',iv,' @ ',real(valr(iv)),
     x				' with norm ',real(S2),' ignored'
	   go to 500
	else
	   S2 = 1.0/sqrt(S2)
	endif
	IMAX2Z=0
	IMAX2Y=IMAX2
	IMAXY=IMAX
	if(EQN.eq.'T') then
c				RECONSTRUCT Y EIGENVECTOR
	  rewind 28
	  read(28,*) IMAX2Y,IMAX3
	  IMAXY=IMAX3 + IMAX2Y
	  IMAX2Z=IMAX3
c	write(6,*) ' Read in ',IMAX2Y,' Y states, adding to ',IMAX3,' T'
	  do 330 I=IMAX3+1,IMAX3+IMAX2Y
330        read(28,*) II,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(I),(WN1(I,I1),I1=1,IMAXY)
          do 331 I=1,IMAX3
331        read(28,*) II,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x                 JNN3(I),II3(I),(WN1(I,I1),I1=1,IMAXY)
	   do I=1,IMAX3
	     KK2(I) = KK3(I)
	     LL12(I) = LL13(I)
	     LL22(I) = LL23(I)
	     lltot2(I) = lltot3(I)
	     sstot2(I) = sstot3(I)
	     JNN2(I) = JNN3(I)
	     II2(I) = II3(I)
	   enddo
	  do 334 I=IMAX3+1,IMAX3+IMAX2Y
	  do 334 N=0,abs(NMAX)
		II=(abs(NMAX)+1)*(I-1)+N+1
	  vec(II) = 0.0
	  pvec(II) = 0.0
	  do 332 I3=1,IMAX3
		IIT=(abs(NMAX)+1)*(I3-1)+N+1
      	  pvec(II) = pvec(II) + WN1(I,I3) * pvec(IIT) 
332	  continue
334	  continue
	endif
	
	sum(1)=0d0
	sum(2)=0d0
	DO 335 I=1,IMAXY
	chnm(I) = 0.0
	pchnm(I) = 0.0
	XZ=1.0
	ik=2
	if(EQN.ne.'T'.and.I.le.IMAX2.or.EQN.eq.'T'.and.I.gt.IMAX3) then
                XZ=0.5
                ik=1
	    endif
	DO 335 N=0,abs(NMAX)
	II=(abs(NMAX)+1)*(I-1)+N+1
	vecnm(II) = vec(II) * S2
	pvec(II) = pvec(II) * S2 * XZ
	chnm(I) = chnm(I) + vecnm(II)**2
	pchnm(I) = pchnm(I) + pvec(II)**2
335	sum(ik) = sum(ik) + pvec(II)**2
c 	  write(6,*) ' Normalised e-state ',iv
C
C new in eigens68.f: replace physically-normalised vector in vecsr:
	 vecsr(:,iv) = vecnm(:)

	CHIPPED = .false.
	if(iv.eq.iv0.and.MOMDIS) then
	rewind 79
	rmax = 40.0
	step = 0.25
	read(79,*,end=3351,err=3351) rmax,step
3351	  numr = rmax/step
	NPMAX = numr
	if (NPMAX.eq.0) then
	  write(6,*) ' ZERO POINTS ALLOWED FOR 3-BODY WFS!!'
	  rmax = 40.0
	  step = 0.25
	  go to 3351
	 endif
        allocate(CHIP(MCH,NPMAX),Proby(NPMAX,2))
	write(6,*) ' Writing eigenstate in T basis ',iv0,' to file 78'
c	write(78) EGS,IMAX3,6,JTOT,PTY,.true.,EQN.eq.'F',numr,step
C				       threeb FADgs
	write(78) EGS,IMAX3,6,JTOT,PTY,.true.,.false.,numr,step
	write(6,*) '   with ',numr,' steps of ',real(step),' fm.'
	  ICPMAX=max(IMAX,IMAX2Z+IMAX2Y)
	write(6,*) '   Calculating wfs in channels ',1,' to ',
     X			ICPMAX
	  do 339 ir=1,numr
	    r=ir*step
	    U = r/RR
            S=U**2.5d0 * exp(-U*0.5d0) / sqrt(RR)
	  do 336 I=1,max(IMAX,IMAX2Z+IMAX2Y)
336	    CHIP(I,ir) = 0.0
	  do 338 N=0,abs(NMAX)
	    RLL = POLAG(N,5D0,U)*LAGNORM(N,5D0)*S
	  do 338 I=1,ICPMAX
	   II=(abs(NMAX)+1)*(I-1)+N+1
338	   CHIP(I,ir) =  CHIP(I,ir) + pvec(II) * RLL
!	  write(115,*) real(r),(real(CHIP(I,ir)),I=IMAX2Z+1,IMAX2Z+4)
339	   CONTINUE
	 open(135,recl=80,form='formatted')
	 write(135,*) IMAX2,IMAX3,IMAX2Z,IMAX2Y
	 write(135,*) pvec(1:ICPMAX*(abs(NMAX)+1))
	 close(135)

	CHIPPED = .true.

	do 105 I=IMAX2+1,IMAX
	write(78) II2(i),KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),nint(2.*JTARG(II2(I)))
C				Next line (KFAD) only written if FADgs
c	if(EQN.eq.'F') then
c 	  if(I.le.IMAX2) write(78) 2
c	  if(I.gt.IMAX2) write(78) 1
c	else if(EQN.eq.'N') then
c 	  if(I.le.IMAX3) write(78) 1
c	  if(I.gt.IMAX3) write(78) 2
c	 else if(EQN.eq.'Y')then
c  	      write(78) 2
c	 else if(EQN.eq.'T') then
c	      write(78) 1
c	 endif
105      write(78) (CHIP(I,ir),ir=1,numr)
	else 	
	 write(6,*) ' MOMDIS = ',MOMDIS,iv,iv0
	endif

c				Save gs for transition matrix elements
c	if(NMAX.lt.0.and.iv.eq.iv0.and.IJT.le.1) then
	if(iv.eq.iv0.and.IJT.le.1) then
	write(6,*) '   Save GS for response functions', MLT
	    JTOTI = JTOT
	    PARITI = PTY
	    IMAX3GS = IMAX3
	    MLT0 = MLT
      	allocate (KSTGS(IMAX3GS,7),PVECGS(MLL),
     x			PJ0(0:MNM,0:MAXL,-MLT0:MLT0,MJAC))
	do 230 I=1,IMAX3
	  IY = I + IMAX2
	    KSTGS(I,1) = KK3(I)
	    KSTGS(I,2) = LLTOT3(I)
	    KSTGS(I,3) = SSTOT3(I)
	    KSTGS(I,4) = LL13(I)
	    KSTGS(I,5) = LL23(I)
	    KSTGS(I,6) = JNN3(I)
	    KSTGS(I,7) = II3(I)
	    write(10,*) 'KSTGS:',I,(KSTGS(I,J),J=1,7),' @ ',IJT
	    do 230 N=0,abs(NMAX)
	     II0=(abs(NMAX)+1)*(I-1)+N+1
	     II=(abs(NMAX)+1)*(IY-1)+N+1
230	     PVECGS(II0) = pvec(II)
	   do 252 M=1,NJAC
           do 251 N=0,MNM
	   do 251 L1=0,MAXL
	   do 251 LD=-MLT0,MLT0
251        PJ0(N,L1,LD,M)=PJ(N,L1,LD,M)
c          write(99,*)  M,real(XJ(M)),PJ0(0,0,0,M)
252        continue
	   NN0 = NN
	write(6,*) '   Quantum nos saved for response functions'
	else
	write(6,*) '   Use saved GS for response functions', MLT0
	endif

	eigen = 'Scatt'
	if(valr(iv).lt.0) eigen = 'BOUND'
	do iff=6,mxfile,4
	if(abs(vali(iv)).gt.0d0) then
	 write(iff,342) eigen,JTOT,PSIGN(PTY+2),iv,valr(iv),vali(iv)
	else
	 write(iff,341) eigen, JTOT,PSIGN(PTY+2),iv,valr(iv)
	endif
341	format(/1x,a5,f5.1,A1,' EIG',i5,' =',f12.6,:,' @ ',i4)
342	format(/1x,a5,f5.1,A1,' EIG',i5,' =',f12.6,g11.2,:,' @ ',i4)
c	if(valr(iv).lt.1.5.or.iv2.eq.1) then
c	if(valr(iv).lt.3.5.or.iv2.eq.1) then
c	if(valr(iv).lt.0.5.or.iv2.eq.1) then
!	if(valr(iv).lt.1.0.or.iv.eq.iv0) then
	if(valr(iv).lt.EMAX.or.iv.eq.iv0) then
C			Calculate rms of full wfn:
	rms = 0.0
	do 327 I=1,IMAX
	do 327 N=0,abs(NMAX)	
	  II=(abs(NMAX)+1)*(I-1)+N+1
	do 327 I1=1,IMAX
	 if(EQN.eq.'T'.and.I.ne.I1) go to 327
	do 326 N1=0,abs(NMAX)	
	  II1=(abs(NMAX)+1)*(I1-1)+N1+1
326	rms = rms + vec(II) * vec(II1) * RPOWER(N,N1) * WN1(I,I1)
327	continue
	rms =  rms * S2*S2
	rmat = sqrt((AC*RCORE**2 + 2*AN*RN**2 + rms)/(AC+2.*AN))
c	write(iff,328) sqrt(rms),RCORE,rmat
c328	format( ' Rms <rho> =',f7.3,' fm. Using Rcore =',F7.3,' fm,',
c     x          ' rms matter radius =',F7.3,' fm.')
	write(iff,328) sqrt(rms),rmat
328	format( '  Rms <rho> =',f7.3,' fm. ',
     x          ' rms matter radius =',F7.3,' fm.')
	write(iff,329) RCORE,RN,AC,AN
329	format('     using Rcore =',f7.3,', Rvalence =',f7.3,', ',
     X	   ' Acore,Avalence =',2f7.3)

	NSMS = IMAX3**2
	if(iff.eq.6.and.CHIPPED.and.valr(iv)<0..and.IJT==1) then
	write(6,*) '   Calling DENANR:'
        call DENANR(CHIP,numr,KSTGS,IMAX3,EGS,RCORE,AN,AC,ZN,ZC,
     x			step,IMAX2,MCH,NPMAX,MCH,H2M,IMAX3**2)
!		cannot call with IJT>1, as KSTGS not defined properly
	 endif

          write(iff,350) 
350	  format(/' Probability norms in bound state:'//,
     x   '   i:  K  L  S L1 L2 Jnn I#    Normalised      Permuted')
	 PLNORM(-1) = 0.0
	 do 352 LL=0,5
	 PLNORM(LL) = 0.0
	 do 352 IS=0,1
	 do 352 l1l2min=0,5
352	  PLSNORM(LL,IS,l1l2min) = 0.0
	  Jnnmax = -1
	  Kmax = -1
	  if(EQN.ne.'T') write(iff,*)' Y:'
	  if(EQN.eq.'T') write(iff,*)' T:'
	  DO 360 I=1,IMAXY
	  if(EQN.ne.'T'.and.I.eq.IMAX2+1.and.I.ne.1) write(iff,*)' T:'
	  if(EQN.eq.'T'.and.I.eq.IMAX3+1.and.I.ne.1) write(iff,*)' Y:'
	  if(max(pchnm(i),abs(chnm(I))).ge.0e-5.and.
     x    		 abs(chnm(I)).lt.999.) then
	  write(iff,355) I,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(i),
     x                 chnm(I),pchnm(I)
355	  format(1x,I4,5I3,I4,I3,2F14.8)
 	if(iff.eq.10) write(iff,356) (vecnm((abs(NMAX)+1)*(I-1)+N+1),
     x				N=0,min(4,abs(NMAX)))
 	if(iff.eq.10) write(iff,356) (pvec((abs(NMAX)+1)*(I-1)+N+1),
     x				N=0,min(4,abs(NMAX)))
356	  format(5x,6F12.8)
	 else
	  write(iff,357) I,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(i),
     x                 chnm(I),pchnm(I)
357	  format(1x,i4,5I3,I4,I3,1p,2(3x,e11.3))
	endif
	Jnnmax = max(Jnnmax,JNN2(I))
	Kmax = max(Kmax,KK2(I))
        if(I.gt.IMAX2Z.and.I.le.IMAX2Z+IMAX2Y) then
		LL = LLtot2(I)
		IS = SStot2(I)
		l1l2min = min(LL12(I),LL22(I))
	if(LL.le.5.and.l1l2min.le.5) 
     X    PLSNORM(LL,IS,l1l2min) = PLSNORM(LL,IS,l1l2min) + pchnm(I)   
	endif
360 	continue
	write(iff,361) sum 
361	format(/' Norm of Y (beta) channels =',F10.6,
     X	 	    ', of T (alpha) channels =',f10.6/)
         write(iff,*) ' Summary of Y components:'
         write(iff,*) '  LL   S l1,l2 min'
	 do 358 LL=0,5
	 do 358 IS=0,1
	 do 358 l1l2min=0,5
	 L2 = LL
	 if(LL.eq.0.and.l1l2min.eq.0) L2 = -1
	 PLNORM(L2) = PLNORM(L2) + PLSNORM(LL,IS,l1l2min)
358	  if(PLSNORM(LL,IS,l1l2min) .ne. 0.0) 
     X		write(iff,359) LL,IS,l1l2min,PLSNORM(LL,IS,l1l2min)
359	 	format(' ',I4,I4,i4,F14.6)
	 write(iff,3615) (PLNORM(L2),L2=-1,2)
3615	 format(/'   P(S) =',f9.6,',  P(S'') =',f9.6,', P(P) =',
     x		 f9.6,', P(D) =',f9.6/)

C	Calculate norms in jj coupling from IMAX2 basis,
C		   and  in LSJ coupling from IMAX3 basis.
	if(IMAX2Y.gt.0) then
	write(iff,*) ' Norms in jj coupling in Y basis ',
     x		real(valr(iv)),':'
c    X			,Jnnmax,LNCMAX,L2MAX
	S3 = 0.0
	do 370 ic=1,NTARG
	 CNORM(ic) = 0.
	do 370 Jnn=0,Jnnmax
	 CNNORM(Jnn,ic) = 0.
	do 370 L1=0,LNCMAX
	do 370 J1=max(L1-SN,SN),L1+SN
	do 370 L2=0,L2MAX
	do 370 J2=max(L2-SN,SN),L2+SN
	  if(FESH.and.L1+L2.gt.abs(Kmaxf(ic))) go to 370
	   JT = JTARG(ic)
	  PR=.false.
	  S = 0.0
	do 367 K=0,Kmax
	  SK = 0.0
	  do 362 N=0,abs(NMAX)
362	  DSDE(N+1) = 0.
	  do 365 I=IMAX2Z+1,IMAX2Z+IMAX2Y
	  if(L1.ne.LL12(I).or.L2.ne.LL22(I).or.Jnn.ne.JNN2(I).or.
     x	     ic.ne.II2(I).or.abs(J1-J2).gt.Jnn.or.J1+J2.lt.Jnn) goto 365
	  if(K.ne.KK2(I)) go to 365
	  PR=.true.
	  T = SQRT((2*sstot2(I)+1)*(2*LLtot2(I)+1)*(2*J1+1)*(2*J2+1d0))
     x		 * sim9j(SN,  SN,  SStot2(I)+Z,
     x                   L1+Z,L2+Z,LLtot2(I)+Z,
     x			 J1,  J2,  Jnn+Z)
c	  write(6,*) ' Overlap with original ch',I,' is ',real(T)
	  do 363  N=0,abs(NMAX)
	  II=(abs(NMAX)+1)*(I-1)+N+1
363	  DSDE(N+1) = DSDE(N+1) + T*pvec(II)
365	  continue
	  do 366 N=0,abs(NMAX)
366	  SK = SK + DSDE(N+1)**2
	  if(abs(SK).gt.1e-8.and.iff.eq.10) 
     X	  write(10,369) lnames(L1),nint(2*J1),
     X			   lnames(L2),nint(2*J2),Jnn,JT,JTOT,K,SK
367	  S = S + SK
c	 if(abs(S).gt.1e-5) write(iff,368) lnames(L1),nint(2*J1),
	 if(PR) write(iff,368) lnames(L1),nint(2*J1),
     X			       lnames(L2),nint(2*J2),Jnn,JT,JTOT,S
368	 format(2x,'[ ',A1,I2,'/2 + ',A1,I2,'/2 ]',I3,',',
     x		F5.1,';',F5.1,' :',f14.8)
369	 format(2x,'[ ',A1,I2,'/2 + ',A1,I2,'/2 ]',I3,',',
     x		F5.1,';',F5.1,' @ K=',I3,':',f14.8)
	 S3 = S3 + S
	 if(ic.le.5.and.Jnn.le.5) then
	 CNORM(ic) = CNORM(ic) + S
	 CNNORM(Jnn,ic) = CNNORM(Jnn,ic) + S
	 endif
370     continue
	 if(NTARG>1.or.Jnnmax>0) then
	 do 700 ic=1,min(5,NTARG)
700	 write(iff,705) ic,CNORM(ic),(CNNORM(Jnn,ic),Jnn=0,Jnnmax)
705	 format('  Prob(core',i2,') =',f10.6,' from Jnn-s',6f10.6)
	 endif
	if(abs(S3-1d0).gt.1e-6) write(iff,371) S3
371	format('  Total norm in jj basis =',F10.6/)
	endif
	if(IMAX3.gt.0) then
	write(iff,*) 
	write(iff,*) ' Norms in LSJ coupling in T basis:'
! 	write(iff,*) NTARG,Jnnmax,LNCMAX,L2MAX,SMAX,Kmax,NMAX,TT,Kmaxf
	S3 = 0.0
	do 380 ic=1,NTARG
	do 380 Jnn=0,Jnnmax
	do 380 L1=0,LNCMAX
	do 380 L2=0,L2MAX
	do 380 SS=0,SMAX
	do 380 J2=abs(L1-SS),L1+SS
	   if(mod(L1+SS+TT,2).ne.1) go to 380
	   if(FESH.and.L1+L2.gt.abs(Kmaxf(ic))) go to 380
	   JT = JTARG(ic)
	  PR=.false.
	  S = 0.0
	do 376 K=0,Kmax
	  do 372 N=0,abs(NMAX)
372	  DSDE(N+1) = 0.
	  DO 375 I=1,IMAXY
	  if(EQN.ne.'T'.and.I.le.IMAX2) go to 375
	  if(EQN.eq.'T'.and.I.gt.IMAX3) go to 375
!	  do 375 I=IMAX2+1,IMAX
	  if(L1.ne.LL12(I).or.L2.ne.LL22(I).or.Jnn.ne.JNN2(I).or.
     x	     ic.ne.II2(I).or.abs(L2-J2).gt.Jnn.or.L2+J2.lt.Jnn) goto 375
          if(abs(Jnn-JT).gt.JTOT.or.Jnn+JT.lt.JTOT) go to 375
	  if(K.ne.KK2(I)) go to 375
	   PR=.true.
	  T = SQRT((2*LLtot2(I)+1)*(2*J2+1d0))
     x		 * racah(SS+Z,L1+Z,Jnn+Z,L2+Z,J2,LLtot2(I)+Z)
	  do 374  N=0,abs(NMAX)
	  II=(abs(NMAX)+1)*(I-1)+N+1
374	  DSDE(N+1) = DSDE(N+1) + T*pvec(II)
375	  continue
	  do 376 N=0,abs(NMAX)
376	  S = S + DSDE(N+1)**2
c	 if(abs(S).gt.1e-5) write(iff,378) 2*SS+1,llnames(L1),nint(J2),
	 if(PR) write(iff,378) 2*SS+1,llnames(L1),nint(J2),
     X				lnames(L2),Jnn,JT,JTOT,S
378	 format(2x,'[ ',I1,A1,I1,' + ',A1,' ]',I3,',',
     x		F5.1,';',F5.1,' :',f14.8,3x,L2)
	 S3 = S3 + S
380     continue
	if(abs(S3-1d0).gt.1e-6) write(iff,381) S3
381	format('  Total norm in LSJ basis =',F10.6/)
	endif

	endif
	enddo
!@@	if(valr(iv).lt.0.0.or.iv2.eq.1) then
	  if(iv.eq.iv0) then
c	  write(8,*) IMAX2,IMAX3
c				Save weights of first eigenstate:
!	  do 384 I=1,IMAX
!384       write(8,357) I,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
!     x                 JNN2(I),II2(i),chnm(I),pchnm(I)
	  endif

	  drr = 0.25
	  NR = XL(NLAG)*RR/drr
	  write(18,385) drr,NR,IMAX,JTOT,PTY,valr(iv),iv,valr(iv),S3
385       format('#',f8.4,2i4,f4.1,i2,f10.5/'# Eigensolution ',i4,
     X	     ' at E = ',g12.4,' in T basis, with T-basis norm',f10.6
     X         / '#    i:  K  L  S L1 L2 Jnn I#')

	  S = 1d0/sqrt(RR)
	  NS = (IMAX3-1)/10+1
	  do 396 IS=1,NS
	   nc = min(10,IMAX3-(IS-1)*10)
	   do 387 ic=1,nc
	   I=(IS-1)*10 + ic
	   write(18,386) I,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x                 JNN3(I),II3(I)
386	  format('#',1x,I4,':',6I3,I4,I3)
387	   continue
	  do 390 ir=1,NR
	    r = ir*drr
	    U = r/RR
            S=U**2.5d0 * exp(-U*0.5d0) / sqrt(RR)
	  do ic=1,nc
	   chnm(ic) = 0.0
	   enddo
	  do 388 N=0,abs(NMAX)
	    RLL = POLAG(N,5D0,U)*LAGNORM(N,5D0)*S
	  do 388 ic=1,nc
	   I=(IS-1)*10 + ic
	   IY=IMAX2+I
	   II=(abs(NMAX)+1)*(IY-1)+N+1
388	  chnm(ic) = chnm(ic) + RLL*pvec(II)
390	  write(18,395) r,(chnm(ic),ic=1,nc)
395	  format(f7.3,1p,10e12.4)
396	write(18,*) '&'
	call flush(18)
	call flush(6)
	if(MOMDIS.and.iv.eq.iv0)   then
C			Calculate <2|3> overlaps for any transfer states
!      write(6,*) 'NBS,NTR,NX,MCH =',NBS,NTR,IMAX2,NX,MCH
	novplot = 0
      do 400 NIB=1,NBS
        IB1 = KNF(NIB)
        IB0 = IB1-1
        IB2 = KNL(NIB)
	NB=IB2-IB0
        if(KIND(NIB).lt.3.or.IMAX2Y.eq.0) go to 400
        if(KIND(NIB)==3.or.KIND(NIB)==5) then
C ****         Y transfer state  of sum(LV,JV,JC): (SV,LV)JV,JC;JTV
C              with overall coupling (SV,LV)JV,JC;JTV + (lamm,SV)jamm  = JJ
           samm = SN
           INCOH = 1
        else
C ****         T transfer state  of sum(JV,L): (SN,SN)JV, L;JTV
C              with overall coupling (SN,SN)JV, L;JTV + (JTARG,lamm)jamm  = JJ
           INCOH = NTARG
	   write(6,*) 'KIND = 4,6 OVERLAPS NOT IMPLEMENTED'
	   go  to 400
        endif
	I = IMAX2Z+1
	write(6,*)
	write(6,398) IB1,JTV(IB1),PSIGN(PRT(IB1)+2),valr(iv)
!     x			,IMAX2Z+1,IMAX2Z+IMAX2Y
	write(6,*) 'Overlap with bs at ',BEV(IB1)
398	format( 'Overlap with 2-body bound state # ',i3,':',f5.1,a1,
     X		' with 3-body bs @',f8.4,:,' (',i4,' to ',i4,')')
	call Overlap32(NB,NX,DX,JTV(IB1),PRT(IB1),LV(IB1),JV(IB1),
     X		ICV(IB1),MX,YBS(1,IB1), CHIP,MCH,NPMAX,step,I,
     X		IMAX2Y,JTOT,PTY,JTARG,  valr(iv),PSIGN,BEV(IB1),
     X		KK2,LLtot2,sstot2,LL12,LL22,JNN2,II2, L2MAX,
     X		H2M,AC,XJ,WJ,NJAC,PJ,MNM,MAXL,MLT,IB1,iv,SN,novplot)
	go to 400

	call Overlapp32(NB,NX,DX,JTV(IB1),PRT(IB1),LV(IB1),JV(IB1),
     X		ICV(IB1),MX,YBS(1,IB1), CHIP,MCH,NPMAX,step,I,
     X		IMAX2Y,JTOTI,PARITI,JTARG,  valr(iv),
     X		KK2,LLtot2,sstot2,LL12,LL22,JNN2,II2, L2MAX,
     X		AC,XJ,WJ,NJAC,PJ,MNM,MAXL,MLT,IB1,iv,
     X    	ASPL,NYP2,NYMAX,NY,DY)
!	
400	continue
      	call Moment(pvec,abs(NMAX),IMAX2,IMAX3,XJ,WJ,PJ,WL,XL,RMAX,
     X	   MNM,MJAC,MLAG,MAXL,MLT,MCH,ML ,MKMAX,NPMAX,
     X	   NJAC,NLAG,AC,AN,RR,RCORE,RN,CHIP,
     X	   KK3,LLTOT3,SSTOT3,LL13,LL23,II3,JNN3)

	endif
!@@      endif
	if(CHIPPED) deallocate(CHIP,Proby)
	if(valr(iv).gt.0..and..not.FESH) then
C				CALCULATE RESONANCE WIDTHS IN T BASIS
	DO 405 I=IMAX2+1,IMAX
405	XNI(I) = 0.0
	DO 410 IC=1,NTARG
	DO 410 IK=1,MKMAX
410   	BESSJ(IK,IC)=0.0
         ALMIN= 0.5D0
         ALMAX= MKMAX+ 1.5D0
	 CF1 = ZEFF*coulcn/H2M
	 write(10,*)  'RES1: ZEFF,coulcn,CF1 =',ZEFF,coulcn,CF1 
	  S = 1d0/sqrt(RR)
	  S = 1d0

      	DO 450 J=1,NLAG
	  DO 415 IC=1,NTARG
          T = valr(iv)-ETARG(IC)
	  if(T.lt.0.0) go to 415
          WVK = sqrt(T/H2M)
	  RHO   = RR*XL(J) * WVK
	  ETA = CF1/(2d0*WVK)
	   write(10,*)  'RES: J,WVK,RHO,ETA =',J,WVK,RHO,ETA
        IF(RHO**ALMAX.gt.1e-3)
     *   CALL  COULFG(RHO,ETA,ALMIN,ALMAX,BESSJ(1,IC),FC,FC,FC,
     * 			3,0,IFL,M1)
415	continue

C ***  CALCULATION OF WAVE FUNCTION ***    (T & Y)
	DO 420 I=1,IMAX
	pchnm(I) = 0.0
	DO 420 N=0,abs(NMAX)
	 II=(abs(NMAX)+1)*(I-1)+N+1
420	pchnm(I) = pchnm(I) + VEC(II) * RL(N,J) * S

C				CHNM = V * wftn    (T & Y)
	  DO 422 I2=1,IMAX
	  CHNM(I2) = 0.0
	  DO 421 I=1,IMAX
421	   CHNM(I2) = CHNM(I2) + WW(I2,I,J) * pchnm(I)
422	  CHNM(I2) = CHNM(I2) - CF1/(RR*XL(J)) * pchnm(I2)

C ***  CALCULATION OF DECAY WIDTH IN T BASIS ONLY***
	DO 430 I1=IMAX2+1,IMAX
	  if(valr(iv)-ETARG(II2(I1)).lt.0.0) go to 430
	  VP = 0.0
	  DO 425 I2=1,IMAX
	     XZ=1.0
c	     if(I2.le.IMAX2) XZ=0.5
425	   VP = VP + WN1(I1,I2)*XZ * CHNM(I2)
	 XNI(I1) = XNI(I1) + WL(J) * BESSJ(KK2(I1)+2,II2(I1)) * VP
430	 continue
450	continue

      S  = 0.D0
      DO 465 I1= IMAX2+1,IMAX
	  IC = II2(I1)
          T = valr(iv)-ETARG(IC)
	  if(T.lt.0.0) go to 465
          WVK = sqrt(T/H2M)
      XNI(I1) = XNI(I1)**2 * 2.D0/(WVK*H2M)
      S    = S + XNI(I1)
465   CONTINUE
C
C  *** PRINT OF PARTIAL WIDTHS ***
	do 495 iff=6,mxfile,4
	if(iff.ge.6) then
          write(iff,470)  valr(iv)
 470	  format(/' Partial widths of "resonance" at',F9.4,' MeV:'//,
     x   '   i:  K  L  S L1 L2 Jnn I#    Partial width (MeV)')
      	DO 488 I = IMAX2+1,IMAX
	if(abs(xni(i)).gt.1e-8) 
     x 	write(iff,475) I,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(I),XNI(I)
 475	  format(1x,I4,5I3,I4,I3,1p,E12.4)
 488   	continue
	endif
c	  write(6,*) 'Using WW from I=',IMAX2+1,'to ',IMAX
	if(abs(S)>1e-3) then
      	WRITE(iff,491)valr(iv),S
	else
      	WRITE(iff,492)valr(iv),S
	endif
 491    FORMAT(/'  Total Decay Width at',F9.4,' MeV is',F12.6,' MeV',/)
 492    FORMAT(/'  Total Decay Width at',F9.4,' MeV is',1p,E12.4,
     X				' MeV',/)
 495	continue
      endif
500   continue
!	if(NEVALS.gt.0)
!     X		write(20,520) BETA(2),BETA(4),(EVALS(I),I=1,NEVALS)
520	format(2f8.4,10f10.5)

!	if(EMAX.gt.EMIN.and.iv2.gt.2) then
	if(EMAX.gt.EMIN.and.iv2.gt.1) then
	  write(6,*) ' Discretised responses:'
        LL=2
        if(PARITI * PTY.lt.0) LL=1
c	write(6,*) ' Parity ',PARITI,'->',PTY,' so LL =',LL
c	write(6,*) ' J ',JTOTI,'->',JTOT
	if(LL.le.JTOT+JTOTI .and. LL.ge.abs(JTOT-JTOTI)) then
	 write(6,*) '  Finding Coulomb B(E',char(ichar('0')+LL),')'
         WRITE(10+LL,151) LL,JTOTI,PSIGN(PARITI+2),JTOT,PSIGN(PTY+2)
         WRITE(20+LL,151) LL,JTOTI,PSIGN(PARITI+2),JTOT,PSIGN(PTY+2)
	 write(20+LL,150) (EIMAG(J),J=1,4)
150	 format('# Im(E)=',4f12.6)
151       FORMAT('# B(E',I1,') for J=',f5.1,A1,' ->',f5.1,A1)
	endif

         if((-1)**nint(JTOT-JTOTI).eq.PARITI * PTY) then
                STR = 0
           else
                STR = 1
           endif
                JTR = abs(JTOT-JTOTI)
                LTR = abs(JTR-STR)
          WRITE(13,152) LTR,STR,JTR,JTOTI,PSIGN(PARITI+2),
     X                  JTOT,PSIGN(PTY+2)
          WRITE(23,152) LTR,STR,JTR,JTOTI,PSIGN(PARITI+2),
     X                  JTOT,PSIGN(PTY+2)
	  write(23,150) (EIMAG(J),J=1,4)
152       FORMAT('# LSJ =',3I2,' for J=',f5.1,A1,' ->',f5.1,A1)
	  write(6,153) LTR,STR,JTR
153	  format('   Finding LSJ= ',3I1,' strength function')
c		Note: could have chosen any  LTR,STR,JTR here!
c
	do 530 N=0,abs(NMAX)
	do 530 N1=0,abs(NMAX)
	RP = 0.
	do 528 i=1,NLAG
528	   RP = RP + (XL(i)*RR)**LL * WL(i) * RL(N,i) * RL(N1,i)
530	   RPOWER(N,N1) = RP

c				Calculate discretised Ek & response functions
	IE = 0
	DO 600 iv=iv2,1,-1
	  EC = valr(iv)
	  if(EC.gt.EMAX*2) go to 600
	  if(IJT.eq.1.and.iv.eq.iv0) go to 600
	  IE = IE+1
	  BEL(IE,0) = EC
	  BEL(IE,1) = 0.0
	  BEL(IE,2) = 0.0

C ***** Normalise solution vector with norm matrix WN1
	S2 = 0.0
	DO 534 I=1,IMAX
	DO 534 N=0,abs(NMAX)
	II=(abs(NMAX)+1)*(I-1)+N+1
	S=0.
	DO 532 I1=1,IMAX
	N1=N
	II1=(abs(NMAX)+1)*(I1-1)+N1+1
532	S=S+WN1(I,I1)*vecsr(II1,iv)
	S2 = S2 + S*vecsr(II,iv)
534	pvec(II) = S
c	if(S2.lt.0.) write(6,*) ' E-state # ',iv,' @',real(EC),
c    x		' has init norm',real(S2),'!'
	if(S2.le.thresh) then
	   write(10,*) '  E-state ',iv,'@',real(valr(iv)),
     x				' with norm',real(S2),' ignored'
	   go to 600 
	   endif
	S2 = 1.0/sqrt(S2)

	DO 535 I=IMAX2+1,IMAX
c	XZ=1.0			always true for T states
	DO 535 N=0,abs(NMAX)
	  II=(abs(NMAX)+1)*(I-1)+N+1
535	pvec(II) = pvec(II) * S2 
	write(10,*) ' Estate # ',iv,'/',iv2,' @',real(EC),' normalised'

c	`Radial' integrals:
	    do 545 IGS=1,IMAX3GS
	    do 545 IY=IMAX2+1,IMAX
	    T = 0.0
	    do 542 N=0,abs(NMAX)
	     IIGS0=(abs(NMAX)+1)*(IGS-1)+N+1
	     II=(abs(NMAX)+1)*(IY-1)+N+1
542	    T = T +  PVECGS(IIGS0) * pvec(II)
545	    TRCHAN(IY-IMAX2,IGS,0) = T
	write(10,*) ' TRCHAN0 calculated'

!	if(iv2.gt.1)  then
      	CALL CONSF(EC,LTR,ISIG,JTR,TT,KSTEX,IMAX3,JTOT,PTY,
     X	 KSTGS,IMAX3GS,JTOTI,PARITI, PJ,MNM,MAXL,MLT,MJAC,NN,WJ,NJAC,
     X	 PJ0,NN0,MLT0,	DSDE(IE),TRCHAN(1,1,0),MCH,AN,AC,13)
	write(10,*) ' Strf calculated:', DSDE(IE)
!	endif

	if(LL.le.JTOT+JTOTI .and. LL.ge.abs(JTOT-JTOTI)) then
	    do 550 IGS=1,IMAX3GS
	    do 550 IY=IMAX2+1,IMAX
	    T = 0.0
	    do 548 N=0,abs(NMAX)
	    do 548 N1=0,abs(NMAX)
	     IIGS0=(abs(NMAX)+1)*(IGS-1)+N+1
	     II=(abs(NMAX)+1)*(IY-1)+N1+1
548	    T = T +  PVECGS(IIGS0) * pvec(II) * RPOWER(N,N1)
550	    TRCHAN(IY-IMAX2,IGS,1) = T

	    write(4,*) 'EC:',EC
	    do I=1,IMAX3GS
	    write(4,*) 'KSTGS:',I,(KSTGS(I,J),J=1,7),' @ ',IJT
	    enddo
	    call flush(4)
 	  CALL BELMAG(EC,KSTEX,IMAX3,JTOT,KSTGS,IMAX3GS,JTOTI,
     X			BEL(IE,LL),LL,TRCHAN(1,1,1),MCH,AN,AC,ZC,10+LL,
     X			TRCHAN(1,1,0),JTARG,KTARG,QQ(LL))
	  write(10,*) ' BE',LL,' calculated:',BEL(IE,LL)
	 endif

600	continue
	NEDF = IE
	if(NEDF.le.0) go to 631
	IE = 1
	if(abs(BEL(IE,1)).gt.1e-9) write(11,*) '&'
	if(abs(BEL(IE,2)).gt.1e-9) write(12,*) '&'
	if(abs(DSDE(IE)).gt.1e-9)  write(13,*) '&'
	  write(10,*) ' All discrete responses calculated'
	NE = min(MLL,nint((EMAX-EMIN)/abs(DE)))+1
	DE = (EMAX-EMIN)/(NE-1)
	 if(iv2==1) NE=0
	 
	do 630 IE=1,NE
	  EC = EMIN + (IE-1)*DE
	do 620 J=1,4
	BELT(1,J) = 0
	BELT(2,J) = 0
	CONSFLT(J) = 0
	  do 620 I=1,NEDF
	    EDF = BEL(I,0)
	  DEN = EIMAG(J)*0.25/((EC-EDF)**2 + EIMAG(J)**2)
	BELT(1,J) = BELT(1,J) + BEL(I,1) * DEN
	BELT(2,J) = BELT(2,J) + BEL(I,2) * DEN
620	CONSFLT(J) = CONSFLT(J) + DSDE(I)  * DEN

	if(abs(BELT(1,1)).gt.1e-9) write(21,629) EC,(BELT(1,J),J=1,4)
	if(abs(BELT(2,1)).gt.1e-9) write(22,629) EC,(BELT(2,J),J=1,4)
	if(abs(CONSFLT(1)).gt.1e-9)write(23,629)EC,(CONSFLT(J),J=1,4)
629	format(f8.4,4f12.6)
630	continue	
	if(abs(BELT(1,1)).gt.1e-9) write(21,*) '&'
	if(abs(BELT(2,1)).gt.1e-9) write(22,*) '&'
	if(abs(CONSFLT(1)).gt.1e-9)write(23,*) '&'
631	continue	
	endif

	    write(4,*) 'ENGY:',ENGY
	    do I=1,IMAX3GS
	    write(4,*) 'KSTGS:',I,(KSTGS(I,J),J=1,7),' @ ',IJT
	    enddo
	IF(NY.gt.0) close(25)
	return
	end
	subroutine gsfind(KK2,LLtot2,sstot2,LL12,LL22,JNN2,II2,NMAX,
     x                   IIMAX,MCH,vecsr,RR,EGS,FOUND)
      	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	integer KK2(MCH),LL12(MCH),LL22(MCH),LLTOT2(MCH),SSTOT2(MCH),
     &	        JNN2(MCH),II2(MCH),sstot
	dimension vecsr(IIMAX)
	logical FOUND
	FOUND = .false.
c				Read in details of previous eigenvector
	open (36,file ='gsin',
     x          access='sequential',form='formatted',status='unknown')
	rewind 36
	read(36,*,END=100,ERR=100) RR1,EGS
	write(10,*) 'Read gsin file: RR,EGS=',real(RR1),real(EGS)
	if(abs(RR-RR1).gt.1e-5) return
	do 2 II=1,IIMAX
2	vecsr(II) = 0.0

10	read(36,*,END=100,ERR=100) KK,LLtot,sstot,LL1,LL2,
     x                 JNN,ICORE,N,vec
c	write(10,*) KK,LLtot,sstot,LL1,LL2,JNN,ICORE,N,vec
	if(N.gt.NMAX) go to 10
	IT = 0
	do 20 I=1,MCH
	if(KK.ne.KK2(I)) go to 20
	if(LLtot.ne.LLtot2(I)) go to 20
	if(sstot.ne.sstot2(I)) go to 20
	if(LL1.ne.LL12(I)) go to 20
	if(LL2.ne.LL22(I)) go to 20
	if(JNN.ne.JNN2(I)) go to 20
	if(ICORE.ne.II2(I)) go to 20
	II=(NMAX+1)*(I-1)+N+1
	vecsr(II) = vec
20	continue
	FOUND = .true.
	go to 10
100	close(36)
	return
	end
