      SUBROUTINE OCC(YBS,MX,MBS,NV,LV,JV,ICV,JTV,KNF,KNL,JTARG,PTARG,
     x			ETARG,NT,NX,DX,NBS,ITRBS,RNODE,AM1,AM3,H2M,PRT,
     x			LMAX,SV,KIND,NTR,ZN1,ZN2,EOCCMIN,fpot,rcore,MEL,
     X			BEV)
************************************************************************
*                           CORE + N + N with PP                       *
************************************************************************
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      PARAMETER(MAXEQ=7)
      DOUBLEPRECISION    YBS(MX,MBS),FW(MX,MBS,MBS),BEV(MBS)
      CHARACTER LNAMES(8),PSIGN(3),MODE*5,SRCH,MAIN,PART,LLNAMES(8),EIG
	CHARACTER*80 fpot,fmel,fspec
      CHARACTER*8 TFACTS,NORMS*4,KFA*2
      LOGICAL BOX,FAIL3,FRAC,NC,MANY,RENORM,RIN,MEL,BIN,TRES,TDEL,TKNRM,
     x        TKMAT
      INTEGER KIND(MBS),NV(MBS),LV(MBS),ICV(MBS),KNF(MBS),KNL(MBS),
     x		PTARG(NT),PAR,PRT(MBS)
      DOUBLEPRECISION JV(MBS),JTV(MBS),JTARG(NT),ETARG(NT),JTVIN,JT,JS
      REAL*8 ETAP(MAXEQ),KAP2(MAXEQ),SL2(MAXEQ),JOM(MAXEQ),KTARG
      INTEGER LOM(MAXEQ),ICOM(MAXEQ)
        COMMON /DEFORM/NTARG,KKKMAX,KTARG,DEF(2:5)
	COMMON /RESCALE/ VSCALE(0:1)
	  COMMON /ISOSPIN/ ZN,ZC,ISO
	DATA LNAMES / 's','p','d','f','g','h','i','j' /,
     1    LLNAMES / 'S','P','D','F','G','H','I','J' /,
     2     PSIGN / '-',' ','+' / 
      FRAC(X) = ABS(X-INT(X)).GT.1E-5
      FAIL3(X,Y,Z) = FRAC(X+Y+Z) .OR. X.GT.Y+Z .OR. X.LT.ABS(Y-Z)
C
         WRITE(6,*)
         WRITE(6,*) ' Bound States'
      	fmscal = 1./H2M
	etacns = 0.157
	Z = 0d0
      nnode=rnode/dx
      if(nnode.le.10) nnode=NX
	NBS = 0
	NTR = 0
	IB=0
	MANY = .false.
	MANY = .true.
	EOCCMIN = 1d3
      if(MEL) then
       fmel =fpot(1:lnblnk(fpot))//'-sp.mel'
       fspec=fpot(1:lnblnk(fpot))//'-sp.spec'
       write(6,*)  'Writing files: ',
     x        fmel(1:lnblnk(fmel)),', ',fspec(1:lnblnk(fspec))
       write(10,*)  'Writing files: ',
     x        fmel(1:lnblnk(fmel)),',',fspec(1:lnblnk(fspec))
            open (140,file = fmel,access = 'sequential',
     x         form='unformatted',status = 'unknown')
            open (141,file =fspec,access = 'sequential',
     x         form='formatted',status = 'unknown')
	write(141,*) 'Resonances for '//fpot(1:lnblnk(fpot))
      	 amred = am1*am3/(am1+am3)
	 if(am3.gt.999.) amred = am1
      	 h2sm = 1./(amred*fmscal)
	write(141,*) real(h2sm),1.439
	write(141,102) dx,dx,nx,dx,dx,nx,dx*(nx-1)
102	format(2f8.4,i5,2f8.4,i5,f10.5)
	write(141,*) 2,0,4,2,0,1,.true.,.true.,1,ntarg,0
	write(141,'(''  L  s  j Ic JT'')')
* multipliers, jgt
	write(141,'(''  1  2  2  2  2  5'')')
* 2 coupling orders
	write(141,'(''  1  2  3  3  4  5'')')
* masses, charges, sizes
	write(141,1044) AM1,AM3, zn1,zc,0.,rcore
1044 	format(2f10.4,2f5.1,2f5.1,f10.4)
        write(141,1045) 'nucleon',1,sv,0d0,0d0,0d0,1
        write(141,1045) 'core',NT,KTARG,0.,0d0,
     X			(ETARG(i),PTARG(i),i=1,NT)
1045      format(a8,i3,f4.1,2f10.4,10(f8.4,i4))
	write(141,1046) .false.,0.
1046 	  format(L2,f4.1)
       endif

      DO 50 NIB=1,MBS
	MC = 0
      READ(5,*,END=200) KIN,NVIN,LVIN,JTVIN,BE,START,NOMIT,
     x			(MC,i=1,min(1,max(NOMIT,0)))
!      WRITE(6,*) 'BS input:',KIN,NVIN,LVIN,JTVIN,BE,START,NOMIT,MC
      if(KIN.eq.0) go to  200
	RENORM = abs(KIN).gt.10
	RENORM = .false.
	RIN = abs(KIN).le.10
	 IF(KIN.lt.-10) KIN=KIN+10
	call potdef(-1,KKKMAX,x,YBS,RIN,0,0)
	IF(RENORM) then
	 IF(KIN.gt.10) KIN=KIN-10
	 IF(KIN.lt.-10) KIN=KIN+10
	 IF(KIN.ge.5.or.KIN.le.0) then
		WRITE(6,*) ' RENORMALISING TEST EIGENSTATE:'
	     else
		WRITE(6,*) ' RENORMALISING EIGENSTATE:'
	     endif	
	ELSE
	 IF(KIN.ge.7.or.KIN.le.0) WRITE(6,*) ' TEST EIGENSTATE:'
	ENDIF	 
	nc = mod(abs(KIN),2).eq.1
	BIN = KIN==5 .or. KIN==6
!		if(ITRBS>0) write(6,*)  'nc,RIN,RENORM,BIN = ',nc,RIN,RENORM,BIN
      if(nc) then
c				Y=NC occupied or transfer state
      	amred = am1*am3/(am1+am3)
	if(am3.gt.999.) amred = am1
       else
c				Y=NC occupied or transfer state
	am2 = am1
      	amred = am1*am2/(am1+am2)
       endif
      	h2sm = 1./(amred*fmscal)
	CONV = 1./h2sm
c     	write(6,*) 'H2SM =',real(h2sm),AM1,AM3
	do 5 I=1,NOMIT
	read(5,*) LOM(I),JOM(I),ICOM(I)
5	write(6,6) LNAMES(LOM(I)+1),NINT(JOM(I)*2.),ICOM(I)
6	FORMAT(' Omit the lj =',A1,1X,I1,'/2 state for core #',I2)
	if(BIN) then
	  read(5,*) DE,NK,ISC
	   NK = max(NK,10)
	   DE = max(DE,1d-3)
	   ISC = max(ISC,1)
	  if(ITRBS>0) write(6,7) DE,NK,ISC
7	  format(' BIN state',f8.3,' MeV wide of',i4,' points with ',
     X		i1,' weighting')
	endif
	IB1 = IB+1
         IF(ABS(BE).LT.1E-5) THEN
C				search on eigenenergy
	   SRCH='E'
           ISCON=2
           if(START.eq.0.) then
		START = 5.0
                IF(NVIN.lt.0) START = -0.5
		endif
           BE = START
           U = 1.0
	   P = BE
	   theta = 1./h2sm
          ELSE
C				search on central potential
	   SRCH='V'
           ISCON=1
           if(START.eq.0.) START = 1.0
           U = START
	   P = U
	   theta = 0.0
          ENDIF
c
c		take parity from LVIN and parity of g.s.
C		NVIN is required number of nodes in first channel
C		   with L=LVIN
	PAR = (-1)**LVIN
	if(NC) PAR = PAR * PTARG(1)
	M = 0
c	MC= 0
	if(nc) then
c	 write(6,*) ' NT,LMAX,JT,ET,PT =', NT,LMAX,JTARG,ETARG,PTARG
	DO 10 IC=1,NT
	  JT = JTARG(IC)
	DO 10 L=0,abs(LMAX)
	DO 10 JS=max(L-SV,SV),L+SV
	if(ITRBS>4) 
     x	write(6,*) ' Try IC,JT,L,JS =', IC,JT,L,JS,FAIL3(JS,JT,JTVIN)
     x	 ,PAR,(-1)**L , PTARG(IC)

	 IF(FAIL3(JS,JT,JTVIN)) go to 10
	 IF(PAR.ne.(-1)**L * PTARG(IC)) go to 10
	     do 9 i=1,NOMIT
9	     if(L.eq.LOM(i).and.abs(JS-JOM(i)).le..1.and.IC.eq.ICOM(i))
     x		go to 10
	   IB = IB+1
	   M = M + 1
	   if(IB.gt.MBS.or.M.gt.MAXEQ) go to 10
	   LV(IB)=L
	   JV(IB)=JS
	   JTV(IB)=JTVIN
	   PRT(IB)=PAR
	   ICV(IB)=IC
	   ETAP(M) = (ZN1+ZN2)*0.5*ZC*etacns
	   KAP2(M) = ETARG(IC)/h2sm
	   if(ISCON.eq.1) KAP2(M) = KAP2(M) + BE/h2sm
           SL2(M) = JV(IB)*(JV(IB)+1)-LV(IB)*(LV(IB)+1) - SV*(SV+1)
           SL2(M) = SL2(M)*.5
	   if(L.eq.LVIN.and.MC.eq.0) MC = M
10	continue
	else
c				n-n bound state |(SV,SV)JS, LV; JTV>   (JS = S)
	DO 15 L=0,abs(LMAX)
	DO 15 JS=0d0,SV+SV
      if(ITRBS.gt.4) write(6,*) ' Try JTVIN,L,JS =', JTVIN,L,nint(JS),
     x	 FAIL3(L+Z,JS,JTVIN),ISO,nint(L+JS+ISO)

	 IF(FAIL3(L+Z,JS,JTVIN)) go to 15
	 IF(mod(nint(L+JS+ISO),2).ne.1) go to 15
	 IF(mod(L-LVIN,2).ne.0) go to 15
	     do 12 i=1,NOMIT
12	     if(L.eq.LOM(i).and.abs(JS-JOM(i)).le..1.and.IC.eq.ICOM(i))
     x		go to 15
	   IB = IB+1
	   M = M + 1
	   if(IB.gt.MBS.or.M.gt.MAXEQ) go to 15
	   LV(IB)=L
	   JV(IB)=JS
	   JTV(IB)=JTVIN
	   PRT(IB)=PAR
	   ICV(IB)=1
	   ETAP(M) = ZN1*ZN2*etacns
	   KAP2(M) = 0.0
	   if(ISCON.eq.1) KAP2(M) = BE/h2sm
           SL2(M) = JTV(IB)*(JTV(IB)+1)-LV(IB)*(LV(IB)+1) - JS*(JS+1)
           SL2(M) = SL2(M)*.5
	   if(L.eq.LVIN.and.MC.eq.0) MC = M
15	continue
	endif
	if(NOMIT.lt.0) MC = max(1,min(abs(NOMIT),M))
	if(BIN) MC = max(1,min(NVIN,M))
	MC = max(1,min(abs(MC),M))
	IB2 = IB
	
      IF(M.eq.0) then
         WRITE(6,*)
         WRITE(6,*) ' No channels found for b.s. ',NIB
	 go to 50
      endif
      IF(IB.gt.MBS.or.M.gt.MAXEQ) then
         WRITE(6,*)
         WRITE(6,*) ' MBS =',MBS,' should be at least ',IB
         WRITE(6,*) ' MAXEQ =',MAXEQ,' should be at least ',M
	 go to 50
      endif
c	 BOX = abs(KIN) .ge. 5
	 BOX = .false.
	 PART = 'Y'
	 if(mod(abs(KIN),2).eq.0) PART = 'T'
         MODE = 'occup'
	 if(abs(KIN)==3.or.abs(KIN)==4.or.KIN.le.0) MODE = 'bound'
         IF(BE.lt.0.) then
		MODE = 'reson'
		if(LVIN.eq.0.and.abs(ETAP(mc)).lt.1e-6) MODE = 'virt '
		endif
         IF(BOX)          MODE = 'box  '
         IF(BIN)          MODE = 'bin  '
      if(ITRBS.gt.0) then
	write(6,33) MODE,PART,JTVIN,PSIGN(2+PAR),M
	LMX1 = 0
	do 20 II=IB1,IB2
	   MAIN=','
	   if(II.eq.IB1+MC-1.and.IB2.gt.IB1) MAIN='*'
	   LMX1 = max(LMX1,LV(II)+2)
	if(nc) then
        WRITE(6,17) II,ABS(NVIN),LNAMES(LV(II)+1),INT(JV(II)*2.+0.5),
     x		  MAIN,JTARG(ICV(II)),JTV(II),PSIGN(2+PAR),BE
 17     FORMAT(2X,I2,': [',I2,A1,1X,I1,'/2',A1,F4.1,']',F3.1,A1
     X  ,' at',F7.3,' MeV')
	else
	 WRITE(6,18) II,ABS(NVIN),MAIN, nint(2*JV(II)+1),
     x		 LLNAMES(LV(II)+1),nint(JTV(II)), BE
 18   FORMAT(2X,I2,': ',I2,A1,2x,i2,A1,I1,' at',F7.3,' MeV')
	endif
 20    CONTINUE
	if(.not.BIN) write(6,*) ' Searching for ',SRCH,
     x      ' from ',real(START)
	endif
	if(MEL.and.nc) then

	  write(141,*) ' J,pi=',real(JTVIN),PAR
	  write(141,106) nint(2*JTVIN),PAR,M,0,0.0,0.0
106       format(4i5,f10.5,g12.4)
	  write(141,*) (1,i=IB1,IB2)
	  write(141,*) (1,i=IB1,IB2)
	  write(141,*) (ICV(i),i=IB1,IB2)
	  write(141,*) (LV(i),i=IB1,IB2)
	  write(141,*) (nint(2*SV),i=IB1,IB2)
	  write(141,*) (nint(2*JV(i)),i=IB1,IB2)
	  write(141,*) (nint(2*JTARG(ICV(i))),i=IB1,IB2)
	  write(141,*) (nint(2*JTVIN),i=IB1,IB2)
	  write(141,*) 0,0
!	write(141,'(''  L  s  j Ic JT'')')
	  do 108 I=IB1,IB2
	  do 108 J=I,IB2
	  do 107 ir=1,nx
	  rad = (ir-1)*dx + dx
107    	  YBS(ir,IB1)=POT(rad,LV(I),LV(J),JTARG(ICV(I)),JTARG(ICV(J)),
     X              JV(I),JV(J),SV,1d0,SL2(I-IB1+1),JTVIN,
     X		    I-IB1+1,J-IB1+1,abs(KIN),RIN)
108	  write(140) (YBS(ir,IB1),ir=1,nx)
	 if(LMAX<0.or.(ISCON==2.and.START<0.)) then
	  if(RIN) write(6,33) MODE,PART,JTVIN,PSIGN(2+PAR),M
	  if(.not.RIN) write(6,34) MODE,PART,JTVIN,PSIGN(2+PAR),M
	do  II=IB1,IB2
	   MAIN=','
	   if(II.eq.IB1+MC-1.and.IB2.gt.IB1) MAIN='*'
	if(nc) then
     	 WRITE(6,37) II,MODE,PART,ABS(NV(II)),LNAMES(LV(II)+1),
     x		  INT(JV(II)*2.+0.5),MAIN,JTARG(ICV(II)),JTV(II),
     x		  PSIGN(2+PAR),BE
	else
	WRITE(6,38) II,MODE,PART, ABS(NVIN),MAIN, nint(2*JV(II)+1),
     x		LLNAMES(LV(II)+1),nint(JTV(II)),BE
	endif
      	call flush(6)
	if(theta.ne.0) BE = P
	EOCCMIN = min(EOCCMIN, -BE)
 	enddo
	 go to 50
	 endif
	endif
	
	if(.not.BIN) then
!		write(6,*) 'Call eigcc'
     	CALL EIGCC(YBS(1,IB1),LV(IB1),ETAP,KAP2,SL2,THETA,
     X  P,H2SM,BOX,ISCON,JV(IB1),SV,ICV(IB1),JTARG,JTVIN,abs(KIN),AMC,
     #  RIN,MC,abs(NVIN),NV(IB1),nnode,NX,DX,M,ITRBS,MX,FW,40,1d-6,
     #  IFAIL)
	 if(theta.ne.0) BE = P
	 if(theta.eq.0) U = P
	if(SRCH.eq.'E') P = - P
	else
	    I = mod(ISC,10)
            TDEL = I.eq.1 .or. I.eq.2
	    TRES = I.eq.3 .or. I.eq.4 .or. I.eq.7.or.I.eq.8
	    TKMAT= I.ge.5 .and. I.le.8
            TKNRM = ISC.ge.10
            TFACTS = ' without'
            IF(TRES) TFACTS = '    WITH'
            IF(TDEL) TFACTS = 'phase of'
            IF(TKMAT)TFACTS = ' (1-iK) '
            IF(TKMAT.and.TRES)TFACTS = 's(1-iK) '
            NORMS = '  no'
            IF(MOD(ISC,2).EQ.1) NORMS = 'unit'
            KFA = '  '
            IF(TKNRM) KFA = '*k'
	    SRCH = 'e'
	    P = abs(BE); BE = P
	    IFAIL = 0
	    U = 1.0
	    LMX1 = 0
	   do II=IB1,IB2
	   LMX1 = max(LMX1,LV(II)+2)
	   enddo

	 CALL BINCC(YBS(1,IB1),M,KAP2,MC,CONV,ISC,
     &       LV(IB1),JV(IB1),SV,ICV(IB1),JTARG,JTVIN,SL2,P,abs(DE),NK,
     &       ETAP,NX-1,DX,ITRBS,TRES,TDEL,TKMAT,TKNRM,LMX1,abs(KIN),RIN)
	   YBS(NX,IB1:IB2) = 0.0
	endif
	
	EIG = SRCH
	if(MODE.eq.'virt ') then
		P = AMC
		EIG = 'a'
		endif
         IF(IFAIL.ne.0)          MODE = 'FAIL:'
	if(M.gt.1) MANY=.true.
	if(M.gt.1.or.MANY) then
	  if(RIN.and..not.BIN) 
     X      write(6,33) MODE,PART,JTVIN,PSIGN(2+PAR),M,EIG,P
	  if(BIN) write(6,341) MODE,PART,JTVIN,PSIGN(2+PAR),M,P,DE,
     X			TFACTS, KFA,NORMS	
	  if(.not.RIN) write(6,34) MODE,PART,JTVIN,PSIGN(2+PAR),M,EIG,P
	  endif
 33	format(/' Coupled ',A5,1x,A1,' state ',F4.1,A1,' of',i3,
     X		' channels',:, ' with eigenvalue ',A1,' =',F10.3)
 34	format(/' Outside ',A5,1x,A1,' state ',F4.1,A1,' of',i3,
     X		' channels',:, ' with eigenvalue ',A1,' =',F10.3)
 341	format(/' Coupled ',A5,1x,A1,' state ',F4.1,A1,' of',i3,
     X		' channels',:, ' centred @',F8.3,' & width',f6.3,
     X        '; ',A8,' T/D0 ',A2,' & ',A4,' nrm.') 
	TX = 0.0
	do 40 II=IB1,IB2
	X = 0.0
	RX = 0.0
	do 35 I=1,NX
	R = (I-1)*DX
	T = DX*YBS(I,II)**2 * R*R
	X = X + T
35	RX = RX + T* ( R ) **2
	TX = TX + X
	RX = sqrt(RX/(X+1d-20))
	   MAIN=','
	   if(II.eq.IB1+MC-1.and.IB2.gt.IB1) MAIN='*'
	if(nc) then
      WRITE(6,37) II,MODE,PART,ABS(NV(II)),LNAMES(LV(II)+1),
     x		  INT(JV(II)*2.+0.5),MAIN,JTARG(ICV(II)),JTV(II),
     x		  PSIGN(2+PAR),BE,U,SRCH,START,X,RX
 37   FORMAT(2X,I2,'= ',A5,A2,' [',I2,A1,1X,I1,'/2',A1,F4.1,']',F3.1
     X  ,A1,' at',F7.3,' MeV',:,' in',F8.5,'*V <- ',A1,'=',F6.2,
     X   ';',2f6.3)
	else
	WRITE(6,38) II,MODE,PART, ABS(NVIN),MAIN, nint(2*JV(II)+1),
     x		LLNAMES(LV(II)+1),nint(JTV(II)),BE,U,SRCH,START,X,RX
 38   FORMAT(2X,I2,'= ',A5,A2,' ',I2,A1,2x,i2,A1,I1,
     X  ' at',F7.3,' MeV',:,' in',F8.5,'*V <- ',A1,'=',F6.2,';',2f6.3)
	endif
      call flush(6)
	EOCCMIN = min(EOCCMIN, -BE)
	BEV(II) = -BE
 40    CONTINUE
	write(6,*)
	if(ITRBS.gt.0) write(6,*) ' Total sq.norm =',real(TX)
     x			,', total norm =',real(sqrt(TX))
	if(ITRBS.gt.0) write(6,*) 
	if(theta.eq.0.and.RENORM) then
		 II = mod(LVIN,2)
		 VSCALE(II) = P
		 write(6,*) ' POTENTIAL MULTIPLIER FOR [',
     X			PSIGN(3-2*II),'] PARITY SET TO',real(P)
		endif
      IF(KIN.le.6.and.KIN.gt.0.and.IFAIL.eq.0) then
	NBS=NBS+1
	KNF(NBS) = IB1
	KNL(NBS) = IB2
	KIND(NBS) = KIN
	IF(abs(KIN).ge.3) NTR = NTR+1
       else
	IB = IB1-1
       endif
  50   CONTINUE
 200   write(6,*) ' Number of bound states =',NBS,
     x	 	        ', of transfer states =',NTR
	if(MEL) close(140)
	if(MEL) close(141)
      RETURN
      END
      function pot(x,l1,l2,i1,i2,j1,j2,s,pmul,sl2,jtot,i,j,kind,RIN,
     X             ic1,ic2)
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      double precision i1,i2,jtot,ktarg,UNCC(0:5),j1,j2,c(10)
      logical nc,RIN,MONOPEX,VOLCON,CONS,CALLDEF
	COMMON /DEFORM/NTARG,KKKMAX,KTARG,DEF(2:5),BETA(2:5),
     X			VOLCON,CONS,QQ(2:5),MONOPEX
      COMMON /CORES/ICC1,ICC2,CALLDEF,LPOT
	nc = mod(kind,2).eq.1
	do 1 icc=1,10
1	c(icc) = 0
      POT = 0.0 
      if(kkkmax.ne.0.and.nc) then
             if(LPOT==0) LU=min(L1,l2)
             if(LPOT==1) LU=(L1+l2)/2
             if(LPOT==2) LU=max(L1,l2)        ! Policy decision for Boris! (Prev, LU=L1)
             if(LPOT==3) LU=L1                 ! Older Policy
             if(LPOT>=10) LU=mod(LPOT,10)    ! specified quadrupoles etc
	if(CALLDEF) then 
	   call potdef(LU,KKKMAX,x,UNCC,RIN,ic1,ic2)
	   else
	   call potdef(LU,KKKMAX,x,UNCC,RIN,0,0)
	   endif
             if(LPOT>=10) UNCC(0) = UC(l1,x)	! original monopole
	endif
      if(i.eq.j)  then
	if(nc) then
	   if(kkkmax.eq.0.and.RIN) 	POT = UC(l1,x) 
	   if(kkkmax.eq.0.and..not.RIN) POT = UUC(l1,x) 
	   if(kkkmax.ne.0) POT = UNCC(0) 
	else
	   POT = VC(l1,x)
	endif
	c(1) = 1.0
      	if(i.eq.-1) return
      	if(nc.and.RIN) 	    POT = pmul*POT + sl2*ULS(l1,x)
      	if(nc.and..not.RIN) POT = pmul*POT + sl2*UULS(l1,x)
      	if(.not.nc) POT = pmul*POT + sl2*VLS(l1,x)
	c(2) = sl2
	endif
      if(nc) then
c			deformed n-core potential
c			(tensor and core-so potls. not implemented yet)
      do 50 KK=2,KKKMAX
	KKEX = KK
	if(MONOPEX) KKEX=0
	T = FANCDEF2(l1,l2,i1,i2,j1,j2,s,jtot,KKEX)
	POT = POT + UNCC(KK) * T
	c(KK+1)=T
50	continue
      if(l1.eq.l2.and.i1.eq.i2) then
        POT = POT + ULSC(l1,x)*FANCLSC(l1,0,l1,l1,s,j1,j2,i1,jtot)
        POT = POT + ULL(l1,x)*FANCLL(l1,0,l1,l1,s,s,j1,j2,i1,jtot)
	endif
      if(i1.eq.i2) then
        POT = POT + UT(l1,x)*FANCT(l1,l2,0,l1,l2,s,s,j1,j2,i1,jtot)
	endif
      else
c			tensor n-n potential
	if(j1.ge.1d0.and.j2.ge.1d0) then
c					S1 >= 1, S2 >= 1 only
	POT = POT + FANNT(l1,l2,0,l1,l2,nint(jtot),1)*VT(l1,x) 
	if(l1.eq.l2) POT=POT+FANNLL(l1,0,l1,l1,nint(jtot),1)*VLL(l1,x)
	endif
      endif
c	if(kind.ge.10) 
!         write(51,51) i,j,x,(C(icc),icc=1,KKKMAX+1),POT
          if(x<3.) write(51,51) i,j,x,POT
51	format(2I3,10f9.5)
      return
      end
