	DOUBLE PRECISION FUNCTION POLAG(N,AL,X)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CALCULATES LAGUERRE POLYNOMIALS	
	A=1.
	IF(N.EQ.-1) THEN
	 POLAG=0.
	 RETURN
	ELSE IF(N.EQ.0) THEN
	 POLAG=A
	 RETURN
	END IF
	B=AL+1.d0-X
	IF(N.EQ.1) THEN
	POLAG=B
	RETURN
	END IF
	DO 1 I=2,N
	C=((2.d0*I+AL-1.d0-X)*B-(I+AL-1.d0)*A)/I
	A=B
1	B=C
	POLAG=C
	RETURN
	END
