C  The neutron-neutron and the
C neutron-$^4$He interactions are from \protect\cite{gar97} with
C $(V_c^{(l)},r_c^{(l)})$ = (48.2 MeV, 2.33 fm), (-47.40 MeV, 2.30 fm),
C (-21.93 MeV, 2.03 fm) for $s,p$ and $d$ waves respectively. The spin
C orbit parameters are $(V_{so},r_{so})$ = (-25.49 MeV, 1.72 fm). 
C n-alpha potential from Andrea Cobis, PRL letter
	FUNCTION UC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	        uc = 0.0
		if(L.eq.0) uc=+48.00*ddexp(-(r/2.33d0)**2)
		if(L.eq.1) uc=-47.40*ddexp(-(r/2.30d0)**2)
		if(L.eq.2) uc=-21.93*ddexp(-(r/2.03d0)**2)
		RETURN
	ENTRY ULS(L,R)
		s=ddexp(-(r/1.72d0)**2)
		uls=-25.49d0*s
		RETURN
	ENTRY ULSC(L,R)
		ULSC = 0d0
		RETURN
	ENTRY ULL(L,R)
		ULL = 0d0
		RETURN
	ENTRY UT(L,R)
		UT = 0d0
		RETURN
	END
	FUNCTION UUC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	UUC = UC(L,R)
	RETURN
	END
	FUNCTION UULS(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	UULS = ULS(L,R)
	RETURN
	END
