C ****
C ****  Simple S-wave NN potential with scattering length a = -20.0 fm
C ****
	FUNCTION VC(L,R)
		IMPLICIT DOUBLE PRECISION(A-H,O-Z)
		include 'actives.f'
		VC=0D0
		IF(L.EQ.0) VC=-31.D0*DDEXP(-(R/1.8D0)**2)
		RETURN
	ENTRY VLS(L,R)
		if(INIT) ACTIVE(LNNLS)=.false.
		VLS=0.
		RETURN
	ENTRY VT(L,R)
		if(INIT) ACTIVE(LNNT)=.false.
		VT=0.
		RETURN
	ENTRY VLL(L,R)
		if(INIT) ACTIVE(LNNLL)=.false.
		VLL=0.
		RETURN
	END
