	subroutine invitrm(A,ia,ib,n,val,vec,neigs,E1,eps,mc,rhs,p,tr)
	implicit real*8(a-h,o-z)
	dimension A(ia,n),vec(ib,neigs),rhs(n),p(n),val(neigs)
	parameter (zero=0d0, one=1d0)
	logical tr
	real time(2)
c
c	Find neigs eigensolutions nearest to E1 for Ax=Ex 
c	by inverse iteration:  [A-E1] x(n) = x(n-1)
c	
c	At end, val(kv)=E, vec(*,kv)=x for kv=1,neigs, 
c	A destroyed
C
	do 10 i=1,n
	  A(i,i) = A(i,i) - E1
10	continue
	if(tr) write(6,15) neigs,E1
15	format(/' Inverse iteration to find ',i3,' eigenstates nearest'
     x		,F10.5)
	ifail=0
! 	write(6,*) 'invitrm:',n,neigs,E1,eps,mc
! 	write(6,*) 'p(1:3):',p(1:3)
	call flush(6)

c			L.R decomposition 
	  call dgetrf(n,n,A,ia,p,ifail)
!	  call etime(time); write(6,'('' cpu: '',f8.3)') time(1)
	if(ifail.ne.0) then
	     write(6,*)' Singular Matrix decomposition for this energy'
	      stop 'invitr'
	endif
	do 300 kv=1,min(neigs,n)
c			starting vector
	do 20 i=1,n
20	rhs(i)=one/sqrt(real(n))
c	rhs(1) = one
	E = zero
		
	do 100 ic=1,mc
	  elast = E
	   do 25 i=1,n
25	     vec(i,kv) = rhs(i)
        call dgetrs('N',n,1,A,ia,p,vec(1,kv),n,info)

	do 40 kvp=1,kv-1
	wn = zero
	do 30 i=1,n
30	wn = wn + vec(i,kv)*vec(i,kvp)
	do 35 i=1,n
35	vec(i,kv) = vec(i,kv) - wn*vec(i,kvp)
40	continue
	wn = zero
	do 45 i=1,n
45	wn = wn + vec(i,kv)*rhs(i)
	do 50 i=1,n
	   rhs(i) = vec(i,kv)
50	continue
	an=zero
	do 60 i=1,n
60	  an = an + vec(i,kv)*rhs(i)
	E = E1 + wn/an
	if(tr) write(6,80) ic,E,E-elast
80	format(' Iteration ',I4,' gives ',F10.5,', change =',1P,E10.2)
	call flush(6)
	an = one/sqrt(an)
	do 70 i=1,n
70	  rhs(i) = rhs(i) * an
	val(kv) = E
	if(ic.gt.3 .and. abs(E-elast).lt.eps) go to 200
100	continue
	if(tr) write(6,*) ' Inverse iteration failed after',mc,
     x             ' iterations for state ',kv,' near',real(E)
c	stop
200	do 210 i=1,n
210	vec(i,kv) = vec(i,kv) * an
	if(tr) write(6,*) 
300	continue
	return
	end
