      subroutine projector(PHIA,WRITE15,NFIRST,NLASTR,NMAX,MNMAX,NLAG,
     X	  NPLAG,MLAG,RL,WL,RR,vec,vecgs,pvec,qvec,NSRC,MLL,NSMAX,NORTH,
     X    IMIN,IMAX,EPS,EPS2,kp,DU,YMIN,BLAS,GSF,NSTS,ML,WM,WMA,NSTATE,
     X    JMIN,JMAX,IIMAX,NIB,IB1,IB2,JTV1,lamm,jamm,J,IO,B3,XL,
     X    NNWM2,NNWM)
      implicit none
      logical WRITE15,BLAS,GSF,NORTH,B3
      integer NFIRST,NLASTR,NMAX,NPLAG,NSRC,IMIN,IMAX,NSTS,MNMAX,MLAG,
     X        MLL,ML,NSMAX,NNWM2,NNWM,NLAG,NIB,IB1,IB2,lamm,J,
     X        CHANS(NSMAX),NSTATE,IIMAX,IO(NSMAX,2)
      real*8 KP,DU,YMIN,jamm
      real*8 XL(NLAG),WL(NLAG),RR,RL(0:MNMAX,MLAG),PHIA(NSMAX,MLAG),
     X       VEC(MLL),VECGS(MLL),PVEC(MLL),QVEC(MLL),XNI(NSMAX),
     X       EPS,EPS2,PHIP(NSMAX,MLAG),WM(ML,ML),WMA(ML,ML)

      integer ist2,N,II,IR,isrc,NCHP
      integer i,i0,ii0,NWM,NWM2,JMIN,JMAX
      real*8 s,t,x,z,rms,ro,ycen,aconst,aconst1,epauli,eshift,
     X       epauli2,ONE
      real*8 xovii,xovi,xov5,xov1t,xov6,xn,xna,xnb,xnc,xnd,xov7,
     X       xovv(1000),xov1,xov2,xoviii,JTV1
      real*8 ddot
 	parameter(Z=0d0,ONE=1d0)
     
!	write(6,*) 'NMAX,NPLAG,NSRC =',NMAX,NPLAG,NSRC,B3
c 
      IF(.not.WRITE15) then
C 		Expand occupied state in Gauss-Laguerre basis,
C     		vec(i) = overlap <SS(i)|forbidden>
	do 262 ist2=NFIRST,NLASTR
	do 262 N=0,NMAX
	II=(NMAX+1)*(ist2-1)+N+1
	s=0.
	DO 260 IR=1,NPLAG
260	s=s+RL(N,IR) * PHIA(ist2,IR) * WL(IR)
262	vec(II)=s * sqrt(RR)

	NNWM2 = (NFIRST-1)*(NMAX+1)
	NNWM  = (NLASTR-NFIRST+1)*(NMAX+1)
!?     	xovii = sum(vec(NNWM2+1:NNWM2+NNWM)**2)
        xovii = 0.0
        do N=NNWM2+1,NNWM2+NNWM
          xovii = xovii + vec(N)**2
        enddo

!	write(6,*) ' Expanded in GL basis',real(xovii)
!	do 2625 ist2=NFIRST,NLASTR
!	do 2625 N=0,NMAX
!	II=(NMAX+1)*(ist2-1)+N+1
!2625	vec(II) = vec(II) / sqrt(xovii)
       endif
	xov5 = 0.
	xovi = 0.
       IF(.not.WRITE15) then
	do 2615 IR=1,NPLAG
	do 261 ist2=NFIRST,NLASTR
	do 261 N=0,NMAX
	II=(NMAX+1)*(ist2-1)+N+1
  	 s=RL(N,IR) * PHIA(ist2,IR) * WL(IR)
261	pvec(II)=s * sqrt(RR) 
!?    	xovi = xovi + sum(pvec(NNWM2+1:NNWM2+NWM)**2)
        do N=NNWM2+1,NNWM2+NWM
          xovi = xovi + pvec(N)**2
        enddo
2615	if(GSF)xov5 =xov5+sum(pvec(NNWM2+1:NNWM2+NWM)*vecgs(1:NWM))
	else
	  xovii = 0.
	do IR=1,NPLAG
      	  do ist2=NFIRST,NLASTR
	  xovii = xovii + PHIA(ist2,IR)**2 * WL(IR)
	  enddo
	  enddo
	 xovii = xovii * RR
!	write(6,*) 'xovii',real(xovii)
	endif
	 Xov1t = 0.
	 do II=IMIN,IMAX
	 Xov1t = Xov1t + vec(II)*vecgs(II-NNWM2)
	 enddo
!	 xov6 = Xov1t
	 xov6 = 0.0
C 
C   Orthogonalise this state to all previous states:
      rewind 25
      DO 220 ISRC=1,NSRC-1
c     write(10,*) ' Read src ',ISRC,' for orthogonalisation'
	  xnc = 0.0
	  xnd = 0.0
      if(WRITE15) then
      	read(25) ((PHIP(ist2,IR),IR=1,NPLAG),ist2=NFIRST,NLASTR)
      	xn=Z
	xna = 0.0
	xnb = 0.0
      	do 200 ist2=NFIRST,NLASTR
     	do 200 IR=1,NPLAG
      	t = PHIA(ist2,IR)*PHIP(ist2,IR) * WL(IR)
	xna = xna + PHIA(ist2,IR)**2 * WL(IR)
	xnb = xnb + PHIP(ist2,IR)**2 * WL(IR)
  200 	xn = xn + t
  	if(NORTH) xn = 0.0
      	if(abs(xn).gt.1e-10) then
      	   do 210 ist2=NFIRST,NLASTR
      	   do 210 IR=1,NPLAG
  210 	   PHIA(ist2,IR) = PHIA(ist2,IR)  - xn * PHIP(ist2,IR)
      	endif
      else
	read(25) (pvec(II),II=IMIN,IMAX)
        xn = 0.0
	xna = 0.0
	xnb = 0.0
	xov1 = 0.0
!	Xov1t = 0.0
	do 212 II=IMIN,IMAX
	 t = vec(II) * pvec(II)
	 xna = xna + vec(II)**2
	 xnb = xnb + pvec(II)**2
	 xov1 = xov1 + vec(II)*vecgs(II-IMIN+1)
!	 Xov1t = Xov1t + vec(II)*vecgs(II-NNWM2)
  212	 xn = xn + t
	IF(isrc==1) xoviii = xna
	if(NORTH) xn = 0.0
	xov2 = 0.
	if(abs(xn).gt.1e-10) then
	  do 214 II=IMIN,IMAX
          vec(II) = vec(II) - xn * pvec(II)
	  xov2 = xov2 + vec(II)*vecgs(II-IMIN+1)
          xnc = xnc + vec(II)*pvec(II)
  214     xnd = xnd + vec(II)**2
	 xov6 = xov6 - xn*XOVV(ISRC)
	endif
      endif
      if(abs(xn).gt.0.001) write(10,215) NSRC,ISRC,xn,xna,xov2,xov6
c      if(abs(xn).gt.0.01) write(10,215) NSRC,ISRC,xn,xna,xnd
  215 format(' Overlap of state ',I3,' to ',I3,' =',f12.6,' Ns=',3f10.4)
  220 CONTINUE 

C 
C   Normalise this state:
      xn=Z
      rms = Z
      if(WRITE15) then
	NCHP = 0
      	do 250 ist2=NFIRST,NLASTR
      	x = Z
      	do 245 IR=1,NPLAG
	 RO = RR*XL(IR)
      	t = PHIA(ist2,IR)**2 * WL(IR)
      	x = x + t
  245 	rms = rms + t * RO**2
      	xni(ist2) = x
	if(x.gt.EPS) then
	   NCHP = NCHP+1
	   chans(NCHP) = ist2
	endif
  250 	xn = xn + xni(ist2)
      	rms = sqrt(rms/(xn+1e-9))
!      	write(6,1020) NSRC,xn,rms,NCHP,JMIN,JMAX
      	write(6,1020) NSRC,xn,xovii,rms,NCHP,JMIN,JMAX
c    X             ,(chans(ist2),xni(chans(ist2))/xn,ist2=1,NCHP)
      	write(10,1020) NSRC,xn,xovii,rms,NCHP,JMIN,JMAX,
     X              (chans(ist2),xni(chans(ist2)),ist2=1,NCHP)
 1020 format(' Source # ',I3,' has norm ',2F10.5,:,' and rms RO ',F8.3,
     X',',I4,' >eps',2I4,:,' from partial waves:',/,(1x,6(i3,F9.5,1x)))
      else 
	do 255 ist2=NFIRST,NLASTR
	x = 0.0
	do 254 N=0,NMAX
	II=(NMAX+1)*(ist2-1)+N+1
  	t = vec(II)**2
  254   x = x + t
      	xni(ist2) = x
  255 	xn = xn + xni(ist2)
      	if(B3) then
      	 write(6,1022) NSRC,xn,xovii
	else
	 ycen = -log(one - kp*J*DU)/KP + YMIN
         write(6,1022) NSRC,xn,xovii,ycen
        endif
      	write(10,1022) NSRC,xn,xovii,ycen,NSTATE,1,NPLAG,
c    X              (chans(ist2),xni(chans(ist2)),ist2=NFIRST,NLASTR)
     X              (ist2,xni(ist2),ist2=NFIRST,NLASTR)	
 1022 format(' Source # ',I3,' has norm ',2F10.5,:,' and Y centre ',F8.3
     X,',',I4,' >eps',2I4,:,' from partial waves:',/,(1x,6(i3,F9.5,1x)))
      endif
      if(xn.lt.EPS2) then
C  This state is already excluded
         write(6,*) '         Ignore source as already included'
     x              ,' or norm too low.'
	 NSRC = NSRC - 1
	 go to 270
	 endif
      t = 1d0/sqrt(xn)
      if(WRITE15) then
C write cumulative set of PP states to file 15, 
         if(EPS.le.0.) then
c          write(15) ((PHIA(ist2,IR)*t,IR=1,NPLAG),ist2=NFIRST,NLASTR)
           write(15) ((PHIA(IO(ist2,1),IR)*t,IR=1,NPLAG),
     X				ist2=1,NLASTR-NFIRST+1)
         else
           write(15) NCHP,JMIN,JMAX,(IO(chans(ist2),2),ist2=1,NCHP),
     X         ((PHIA(chans(ist2),IR)*t,IR=JMIN,JMAX),ist2=1,NCHP)
         endif
      else
c --------------------------------------------
C 		Expand occupied state in Gauss-Laguerre basis,
C		and project Hamiltonian matrix WM off occupied state
c
c       i.e. matrix elements for QQ.H.QQ, 
c	where QQ = 1 - |forbidden><forbidden|
c
C     vec(i) = overlap <SS(i)|forbidden>
	do 263 II=IMIN,IIMAX
263	vec(II) = vec(II)*t
	xov6 = xov6*t
	xov2 = xov2*t
c
	aconst1=0d0
	epauli=0d0
	xov7=0.
	do i=IMIN,IIMAX
	  i0 = i-IMIN+1
	  if(NORTH) then
	  do ii=IMIN,IIMAX
	    ii0 = ii-IMIN+1
	    epauli=epauli+vec(ii)*vec(i)*WMA(i0,ii0)
	    enddo
	   endif

	  if(BLAS) then
	    pvec(i)=ddot(NWM,WM(i0,1),ML,vec(IMIN),1)
	    qvec(i)=ddot(NWM,WM(1,i0),1 ,vec(IMIN),1)
	  else
	  pvec(i)=0
	  qvec(i)=0
	  do ii=IMIN,IIMAX
	    ii0 = ii-IMIN+1
	    pvec(i)=pvec(i)+WM(i0,ii0)*vec(ii)
	    qvec(i)=qvec(i)+WM(ii0,i0)*vec(ii)
	  enddo
	  endif
	  aconst1=aconst1+pvec(i)*vec(i)
	  xov7 = xov7 + vec(i)*vecgs(i0)
	enddo

	Eshift=1000.d0
	aconst = aconst1 + Eshift
	if(BLAS) then
	  call dger(NWM,NWM,-1d0,vec(IMIN),1,qvec(IMIN),1,WM,ML)
	  call dger(NWM,NWM,-1d0,pvec(IMIN),1,vec(IMIN),1,WM,ML)
	  call dger(NWM,NWM,aconst,vec(IMIN),1,vec(IMIN),1,WM,ML)
	else
	do i=IMIN,IIMAX
	do ii=IMIN,IIMAX
	  i0 = i-IMIN+1
	  ii0 = ii-IMIN+1
	  WM(i0,ii0)=WM(i0,ii0)-(vec(i)*qvec(ii)+vec(ii)*pvec(i))
     &    +aconst*vec(i)*vec(ii)
	enddo
	enddo
	endif
	
	epauli2=0d0
	if(GSF) then
	do i=IMIN,IIMAX
	  i0 = i-IMIN+1
	  do ii=IMIN,IIMAX
	    ii0 = ii-IMIN+1
	    epauli2=epauli2+vecgs(ii0)*vecgs(i0)*WM(i0,ii0)
	    enddo
	   enddo
	write(10,264) NIB,IB1,IB2,JTV1,lamm,jamm,J,aconst1,
     X			epauli,epauli2
264        format(' Pauli energy b.s.',i2,' (',I2,' to',I3,
     X		',',f4.1,') with l,j =',I2,F5.1,
     X		' & IY =',i3,':',2f9.3,f10.5/)
	   endif
	write(10,265) NIB,JTV1,lamm,jamm,NSRC,Xov1t,xov2,xov6, 
     X		epauli2,aconst1*xov7**2,aconst*xov7**2,1.-xn/xovii,t
265        format(' OV ',i2,'(',f4.1,')=',I2,F4.1,
     X		' NS =',i3,':',f9.6,2f8.4,3f9.3,f7.4,f7.3/)
       XOVV(NSRC) = xov2

c --------------------------------------------
      endif
C
C Write set for current J-pi to file 25
c     write(10,*) ' Write src ',ISRC,' to file 25'
      if(WRITE15) then
      	  write(25) ((PHIA(ist2,IR)*t,IR=1,NPLAG),ist2=NFIRST,NLASTR)
	else
	  write(25) (vec(II),II=IMIN,IMAX)
	endif
c     if(PRIPOT.and.WRITE15) then
      if(WRITE15) then
      do 268 IR=JMIN,JMAX
	 RO = RR*XL(IR)
  268 write(16,1030) RO,(PHIA(ist2,IR)*t,ist2=NFIRST,
     X                                   NFIRST+min(10,NSTS)-1)
 1030 format(f8.3,10f8.4)
      write(16,*) '&'
      endif
  270 return
      end
