	SUBROUTINE REDHAM(EQN,WN1,WW, MCH,NLAG, CTN,DTN,KKN,ICN,
     x	  KK2,II2,IMAX2,IMAX3,IMAX,IMAX2H,IMAX3H,IMAXH,PR)
                                                                       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  WN1(MCH,MCH),WW(MCH,MCH,NLAG),
     x	CTN(MCH,MCH),DTN(MCH,MCH),WWL(MCH,MCH)
      INTEGER KKN(MCH),ICN(MCH),KK2(MCH),II2(MCH)
      CHARACTER EQN
      LOGICAL PR,PRT,BLAS
      parameter(ONE=1d0, ZERO=0d0, PRT=.false.,BLAS=.true.)
	
C	Fold Hamiltonian  array and reduce array
C       -----------------------------------------	
	IMAX=IMAX2+IMAX3
	IMAX2H = IMAX2
	IMAX3H = IMAX3
	IMAXH  = IMAX

C************************************ CONVERT TO SCHRODINGER EQUATIONS IF REQD
	if(EQN.eq.'F') then
		return
C*************************
	else if(EQN.eq.'T') then
C			Convert to T-3-basis (usual HH) 

	if(BLAS) then
	  do 160 J=1,NLAG
	   WWL(1:IMAX3,1:IMAX3) = WW(IMAX2+1:IMAX,IMAX2+1:IMAX,J)

	   call dgemm ('n','n',IMAX3,IMAX3,IMAX2,ONE,WN1(IMAX2+1,1),MCH,
     X			WW(1,IMAX2+1,J),MCH,ONE,WWL,MCH)
	   WW(1:IMAX3,1:IMAX3,J) = WWL(1:IMAX3,1:IMAX3) 
160	  continue
	else
	   do 180 I=1,IMAX3
	   do 180 I1=1,IMAX3
	     IY = I+IMAX2
	     I1Y= I1+IMAX2
	   do 180 I2=1,IMAX2
	     do 170 J=1,NLAG
   	   WW(IY,I1Y,J) = WW(IY,I1Y,J) + WN1(IY,I2)*WW(I2,I1Y,J)
170	   continue
180	   CONTINUE
        do 200 I=1,IMAX3
	  do 200 I1=1,IMAX3
	     do 190 J=1,NLAG
190	       WW(I,I1,J) = WW(I+IMAX2,I1+IMAX2,J)
200	  continue
	endif
	
	IMAX2H=0
	IMAX3H=IMAX3
	IMAXH=IMAX3
	if(PR) write(6,*) ' Hamiltonian reduced to ',IMAXH,' T channels'
*	write(6,*) ' Hamiltonian reduced to ',IMAXH,' T channels'
C*************************
	else if(EQN.eq.'Y') then
C			Convert to Y-2-basis 
	do 250 I=1,IMAX2
	do 250 I1=1,IMAX2
	  do 250 I2=1,IMAX3
	    I2Y = I2+IMAX2
	  do 250 J=1,NLAG
250	WW(I,I1,J) = WW(I,I1,J) + WN1(I,I2Y)*WW(I2Y,I1,J) 	

	IMAX3H=0
	IMAX2H=IMAX2
	IMAXH=IMAX2
	write(6,*) ' Hamiltonian reduced to ',IMAXH,' Y channels'
C*************************
	else if(EQN.eq.'N') then
C			Convert to Reduced-orthonormal-basis for Faddeev 
	eps = 1d-5
c            call printm ('WN1 ',WN1,IMAX,IMAX,MCH,10)
        call tnbasis(IMAX,IMAX2,IMAX3,WN1,MCH,CTN,MCH,DTN,MCH,
     X			WWL,eps,NB,PR)
	if(PR)
     x	write(6,*) ' The number of orthoNormal channels =',NB
	if(PRT) then
            call printm ('CTN ',CTN,IMAX,NB ,MCH,10)
            call printm ('DTN ',DTN,NB ,IMAX,MCH,10)
	    call dgemm ('n','n',NB,NB,IMAX,ONE,DTN,MCH,CTN,MCH,
     X			ZERO,WWL,MCH)
            call printm ('D*C ',WWL,NB,NB,MCH,10)
	 endif

	 do 350 J=1,NLAG
	 call dgemm ('n','n',NB,IMAX,IMAX,ONE,DTN,MCH,WW(1,1,J),MCH,
     X			ZERO,WWL,MCH)
	 call dgemm ('n','n',NB,NB,IMAX,ONE,WWL,MCH,CTN,MCH,
     X			ZERO,WW(1,1,J),MCH)
	 do 345 I1=1,IMAX
	 do 345 I2=NB+1,IMAX
345	  WW(I1,I2,J) = 0d0
	 do 346 I1=NB+1,IMAX
	 do 346 I2=1,IMAX
346	  WW(I1,I2,J) = 0d0
350	 continue
            if(PRT) call printm ('DWC ',WW(1,1,1),IMAX,IMAX,MCH,10)
c	NB = IMAX
	IMAX2H=0
	IMAX3H=0
	IMAXH=NB
	
	 do 580 I=IMAX3+1,NB
C			Find K and core states of new orthonormal channels:
	  do 555 I1=1,IMAX
555	  if(CTN(I1,I).ne.0d0) go to 558
	  write(6,*) '''Orthonormal'' state ',I,' all zero!!!??'
558	  KKN(I) = KK2(I1)
	  ICN(I) = II2(I1)
	  if(PRT) write(6,*) 'Using ch',I1,' to find K,core for ',I
580	 continue
        do 590 I=1,IMAX3
           KKN(I) = KK2(IMAX2+I)
590        ICN(I) = II2(IMAX2+I)

	if(PR)
     x	write(6,*) ' Hamiltonian reduced to ',NB,' orthoNormal channels'
	if(PRT) write(6,*) ' KKN:',(KKN(I),I=1,NB)
	if(PRT) write(6,*) ' ICN:',(ICN(I),I=1,NB)
	endif

	RETURN
	END
	SUBROUTINE REDCHS(EQN,SHIFT,WN1,CTN,JNN3,II3,JNN2,II2,
     x     KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     x	   KKN,ICN,IMAXN,IMAXH,MCH,IMAX2,IMAX3,IMAX,FESH,IFO,IMAXF)
                                                                       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  WN1(MCH,MCH),CTN(MCH,MCH)
      INTEGER KK3(MCH),LL13(MCH),LL23(MCH),LLTOT3(MCH),SSTOT3(MCH),
     &        KK2(MCH),LL12(MCH),LL22(MCH),LLTOT2(MCH),SSTOT2(MCH),
     &        JNN3(MCH),II3(MCH),JNN2(MCH),II2(MCH),KKN(MCH),ICN(MCH),
     & 	      IFO(MCH,3)
      CHARACTER EQN
      LOGICAL FESH,SHIFT,W28
      parameter (W28 = .true.)

C	Reduce channel indices and move WN1 array
C       -----------------------------------------	
	IMAX=IMAX2+IMAX3
	rewind 8
	write(8,*) IMAX2,IMAX3
	write(6,*) ' REDCHS: EQN = ',EQN,'; ',IMAX2,IMAX3,IMAXH,IMAXN
	IMAX2I = IMAX2

C************************************ CONVERT TO SCHRODINGER EQUATIONS IF REQD
	if(EQN.eq.'F') then
		return
C*************************
	else if(EQN.eq.'T') then
c			Save old Y,T channels in file 8
c			Save old Y,T channels & T->Y transformation in file 28

          if(W28)  write(28,*) IMAX2,IMAX3,IMAX
	  do 386 I=1,IMAX2
          write(8,357) I,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(i),1.0,1.0
          if(W28)  write(28,*) I,KK2(I),LLtot2(I),sstot2(I),LL12(I),
     x             LL22(I),JNN2(I),II2(i),(WN1(I,IMAX2+I3),I3=1,IMAX3),
     x                                (WN1(I,I2),I2=1,IMAX2)
386       continue
357	  format(1x,6I3,I4,I3,2(3x,g11.3))
	  do 387 I=1,IMAX3
       if(W28) write(28,*) I,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x               JNN3(I),II3(i),(WN1(IMAX2+I,IMAX2+I3),I3=1,IMAX3),
     x                                (WN1(IMAX2+I,I2),I2=1,IMAX2)
387       write(8,357) I,KK3(I),LLtot3(I),sstot3(I),LL13(I),LL23(I),
     x                 JNN3(I),II3(i),1.0,1.0

	if(SHIFT) then
C			Convert to T-3-basis (usual HH) and remove Y states
        do 200 I=1,IMAX3
           KK2(I) = KK3(I)
           LL12(I) = LL13(I)
           LL22(I) = LL23(I)
           lltot2(I) = lltot3(I)
           sstot2(I) = sstot3(I)
           JNN2(I) = JNN3(I)
           II2(I) = II3(I)
	  do 200 I1=1,IMAX3
	    WN1(I,I1) = WN1(I+IMAX2,I1+IMAX2)
200	  continue
	endif
	IMAX2=0
	IMAX=IMAX3
        do iff = 6,10,4
	write(iff,*) 
	write(iff,*) ' New T(3) basis states:'
      DO 1440 I1=1,IMAX3,25
        NCHL = min(I1+24,IMAX3)
        write(iff,1480)
        write(iff,1480)'i:',(mod(i+IMAX2,1000),i=I1,NCHL)
        write(iff,1480)'K3',(kk3(i),i=I1,NCHL)
        write(iff,1480)'L3',(lltot3(i),i=I1,NCHL)
        write(iff,1480)'S3',(sstot3(i),i=I1,NCHL)
        write(iff,1480)'l13',(ll13(i),i=I1,NCHL)
        write(iff,1480)'l23',(ll23(i),i=I1,NCHL)
        write(iff,1480)'Jnn',(JNN3(i),i=I1,NCHL)
 1440   write(iff,1480)'I#',(II3(i),i=I1,NCHL)
 1480   format(1x,A3,25I3,:,/(3x,25i3))
	enddo

C*************************
	else if(EQN.eq.'Y') then
C			Convert to Y-2-basis and remove T states
	IMAX3=0
	IMAX=IMAX2

C*************************
	else if(EQN.eq.'N') then
	write(6,*) 'Convert to OrthoNormal basis'
C			Convert to OrthoNormal basis 
c			Save old channels in file 8
c			Save old channels & norm matrix in file 28
	  if(W28) then
	  rewind 28
	  write(28,*) IMAX2,IMAX3,IMAX
	  endif
	  do 546 I=1,IMAX
          write(8,357) I,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(i),1.0,1.0
546   if(W28) write(28,*) I,KK2(I),LLtot2(I),sstot2(I),LL12(I),LL22(I),
     x                 JNN2(I),II2(i),(WN1(I,I1),I1=1,IMAX)

	IMAX=IMAXN
C			Convert to orthoNormal basis: 
C			first T-3-basis (usual HH) and then some Y states
        do 590 I=1,IMAX3
           KK2(I) = KK3(I)
           LL12(I) = LL13(I)
           LL22(I) = LL23(I)
           lltot2(I) = lltot3(I)
           sstot2(I) = sstot3(I)
           JNN2(I) = JNN3(I)
           II2(I) = II3(I)
590	  continue
        do 595 I=IMAX3+1,IMAX
           KK2(I) = KKN(I)
           II2(I) = ICN(I)
           LL12(I) = 0
           LL22(I) = 0
           lltot2(I) = 0
           sstot2(I) = 0
           JNN2(I) = 0
595	  continue
	  do 620 I =1,IMAX
	  do 610 I1=1,IMAX
610	    WN1(I,I1) = 0d0
620	    WN1(I,I) = 1d0

        do iff = 6,10,4
	write(iff,*) 
	write(iff,*) ' New OrthoNormal basis states:'
      DO 2440 I1=1,IMAX,25
        NCHL = min(I1+24,IMAX)
        write(iff,1480)
        write(iff,1480)'i:',(mod(i,1000),i=I1,NCHL)
        write(iff,1480)'K',(kk2(i),i=I1,NCHL)
        write(iff,1480)'L',(lltot2(i),i=I1,NCHL)
        write(iff,1480)'S',(sstot2(i),i=I1,NCHL)
        write(iff,1480)'l1',(ll12(i),i=I1,NCHL)
        write(iff,1480)'l2',(ll22(i),i=I1,NCHL)
        write(iff,1480)'Jnn',(JNN2(i),i=I1,NCHL)
 2440   write(iff,1480)'I#',(II2(i),i=I1,NCHL)
	enddo
	endif

	if(FESH) then
	write(6,*) 'Compress to Feshbach basis'

	IMAX=IMAXF
C			Compress to Feshbach basis: 
C			first T-3-basis (usual HH) and then some Y states
	if(SHIFT.or.EQN.ne.'T') then
        do 630 I=1,IMAXF
	 J = IFO(I,1)
           KK2(I) = KK2(J)
           LL12(I) = LL12(J)
           LL22(I) = LL22(J)
           lltot2(I) = lltot2(J)
           sstot2(I) = sstot2(J)
           JNN2(I) = JNN2(J)
           II2(I) = II2(J)
630	  continue
	else
        do 631 I=1,IMAXF
	 J = IFO(I,1)
           KK3(I) = KK3(J)
           LL13(I) = LL13(J)
           LL23(I) = LL23(J)
           lltot3(I) = lltot3(J)
           sstot3(I) = sstot3(J)
           JNN3(I) = JNN3(J)
           II3(I) = II3(J)

           KK2(I+IMAX2I) = KK3(J)
           LL12(I+IMAX2I) = LL13(J)
           LL22(I+IMAX2I) = LL23(J)
           lltot2(I+IMAX2I) = lltot3(J)
           sstot2(I+IMAX2I) = sstot3(J)
           JNN2(I+IMAX2I) = JNN3(J)
           II2(I+IMAX2I) = II3(J)
631	  continue
	endif

        do iff = 6,10,4
	  write(iff,*) 
	  write(iff,*) ' New Feshbach basis states:'
          DO I1=1,IMAX,25
            NCHL = min(I1+24,IMAX)
            write(iff,1480)
            write(iff,1480)'i:',(mod(i,1000),i=I1,NCHL)
            write(iff,1480)'o:',(IFO(i,1),i=I1,NCHL)
	if(SHIFT.or.EQN.ne.'T') then
            write(iff,1480)'K',(kk2(i),i=I1,NCHL)
            write(iff,1480)'L',(lltot2(i),i=I1,NCHL)
            write(iff,1480)'S',(sstot2(i),i=I1,NCHL)
            write(iff,1480)'l1',(ll12(i),i=I1,NCHL)
            write(iff,1480)'l2',(ll22(i),i=I1,NCHL)
            write(iff,1480)'Jnn',(JNN2(i),i=I1,NCHL)
 	    write(iff,1480)'I#',(II2(i),i=I1,NCHL)
	else
            write(iff,1480)'K',(kk3(i),i=I1,NCHL)
            write(iff,1480)'L',(lltot3(i),i=I1,NCHL)
            write(iff,1480)'S',(sstot3(i),i=I1,NCHL)
            write(iff,1480)'l1',(ll13(i),i=I1,NCHL)
            write(iff,1480)'l2',(ll23(i),i=I1,NCHL)
            write(iff,1480)'Jnn',(JNN3(i),i=I1,NCHL)
 	    write(iff,1480)'I#',(II3(i),i=I1,NCHL)
	endif
	  enddo
	enddo
	endif

	call flush(8)
	RETURN
	END
	subroutine tnbasis(n,n2,n3,wn1,mchan,ctn,nctn,dtn,ndtn,null,
     x			   thresh,nb,PR)
	implicit real*8(a-h,o-z)
	dimension wn1(mchan,n),ctn(nctn,n),null(n),dtn(ndtn,n)
     x            ,xov(n)
        PARAMETER ( ZERO=0.0D0,ONE=1.D0)
	logical PR

************  Construct orthonormal basis by Gramm-Schmidt,
************  using norm matrix wn1
************  put new basis in *columns* of ctn
	nu = 0
	nb = 0
************  starting with the n3 T basis found for n3 from n2+1
	nb = n3
	do 6 i=1,nb
	 do 5 k=1,n
5	 ctn(k,i)  = ZERO
6	 ctn(i+n2,i) = ONE

	do 100 i=nb+1,n
	 do 10 k=1,n
10	 ctn(k,i)  = ZERO
	 ctn(i-n3,i) = ONE
c			Subtract overlaps with previous basis states:
	 do 20 j=1,nb
!	   xo = ZERO
!	   do 15 m=1,n
!15	   xo = xo + wn1(m,i-n3)*ctn(m,j)
	   xo = ddot(n,wn1(1,i-n3),1,ctn(1,j),1)
20	   xov(j) = xo

	 do 30 k=1,n
	   x1 = ZERO
	 do 21 j=1,nb
21	   x1 = x1 + xov(j) * ctn(k,j)
30	  ctn(k,i) = ctn(k,i) - x1
c
c			Find norm of orthogonalised state:
	 xn = ZERO
	 do 40 ip=1,n
	 do 40 iq=1,n
40	 xn = xn + ctn(ip,i)*wn1(ip,iq)*ctn(iq,i)
	write(10,*) 'Orthogonalised TN state',i,' has norm',real(xn),
     x			' -> ',nb+1
	if(xn.lt.thresh)  then
		nu = nu+1
		null(nu) = i
		if(abs(xn).gt.thresh**2)
     x		write(6,*) 'Proposed orthoNormal channel ',nb+1,
     x		 ' omitted, as norm only',real(xn)
		go to 100
	    endif
	xn = ONE/sqrt(xn)
	nb = nb+1
c			Normalise if possible, and copy into next slot.
	do 50 k=1,n
50	ctn(k,nb) = ctn(k,i) * xn
100	continue
	if(PR) 
     x	 write(6,*) ' Only ',nb,' linearly independent channels'
c			Fill up column vectors with units on null rows
	do 120 i=nb+1,n
	 do 110 k=1,n
110	 ctn(k,i) = ZERO
120	 ctn(null(i-nb),i) = ONE

c 	Now find inverse transformation:  dtn = ctn^T . wn1
	 call dgemm ('t','n',n,n,n,ONE,ctn,nctn,wn1,mchan,
     X			ZERO,dtn,ndtn)

	return
 1100 format (' tnbasis : error return from dgetrf, info = ',i6)
 1110 format (' tnbasis : error return from dgetrs, info = ',i6)
	end
      subroutine mprint ( name, a, n, m, nmax , iout)
      implicit integer (a-z)
      double precision a
      character*4 name
      dimension a(nmax,m)
*
*     mprint -- prints a real matrix a(n,m)
*		name	  -- 4 character identification
*		a(nmax,m) -- array to be printed
*		n	  -- number of rows to be printed
*		m	  -- number of columns to be printed ( .le. 10 )
*		nmax	  -- row dimension of a
*
      write (iout,1000) name, (a(1,i), i = 1, m)
      if ( n .gt. 1 ) then
	 do 10 i = 2, n
	    write (iout,1010) (a(i,j), j = 1, m )
   10	 continue
      endif
      return
*
c1000 format ( '0', a4, 2x, 10g12.4 )
c1010 format ( 7x, 10g12.4 )
c1000 format (  / , a4, 2x, 10f9.5 )
c1010 format ( 6x, 10f9.5 )
c1000 format (  / , a4, 2x, 12f8.4 )
c1010 format ( 6x, 12f8.4 )
 1000 format (  / , a4, 2x, 12f7.3 )
 1010 format ( 6x, 12f7.3 )
      end
      subroutine printm (name,array,n,m,nmax,ifl)
      implicit integer (a-z)
      double precision array
      character*4 name,namec
      dimension array(*)
*
*     printm -- driver for mprint
*
      namec(1:4) = name(1:4)
      nh = 1
      mp = 10
      mp = 12
      i = 0
      iz = ichar('0')
      do 10 nl = m, 1, -mp
         nc = min( nl, mp )
         call mprint (namec,array(nh),n,nc,nmax,ifl)
         i = i + 1
         namec(4:4) = char(iz+mod(i,10)) 
         nh = nh + nmax * nc
   10 continue
      end
