      SUBROUTINE SPLINES(NY,A,NYMAX,NYP2)
************************************************************************
*             SPLINE COEFFICIENTS
************************************************************************
      IMPLICIT DOUBLEPRECISION(A-H,O-Z)
      DOUBLEPRECISION A(0:NYP2,0:NYMAX),B(0:NYMAX,0:NYMAX)

C
      NULL=0
      DO 100 I=1,NY
      DO 90 J=1,NY
      B(I,J)=0.
   90 CONTINUE
      A(I,1)=2.
      B(I,I)=1.
  100 CONTINUE
      DO 120 I=2,NY
      AUXI=-.5/A(I-1,1)
      A(I,1)=A(I,1)+.5*AUXI
      JJ=I-1
      DO 110 J=1,JJ
      B(I,J)=AUXI*B(I-1,J)
  110 CONTINUE
  120 CONTINUE
      DO 140 II=1,NY
      I=NY+1-II
      DO 130 J=1,NY
      S=B(I,J)
                 IF(I.NE.NY) S=S-.5*B(I+1,J)
      B(I,J)=S/A(I,1)
  130 CONTINUE
  140 CONTINUE
C
      DO 160 I=1,NY
             A(NY+1,I)=0.
      A(NULL,I)=A(NY+1,I)
      DO 150 J=1,NY
      A(I,J)=-B(I,J)
      IF(J.NE.1 ) A(I,J)=A(I,J)+B(I,J-1)*.5
      IF(J.NE.NY) A(I,J)=A(I,J)+B(I,J+1)*.5
  150 CONTINUE
  160 CONTINUE
*     write(10,*) 'Spline coefficients'
*     do 163 j=1,ny
*     write(10,*) j
*     write(10,161) (a(iy,j),iy=1,ny)
* 161 format('#',15f8.4)
* 163 continue
 
      return
      end
